function [labels,flag]=cluster_dbscan(X,minPts,Eps,dist_metric)

%x=X';
%[m,n]=size(x);
%Eps=((prod(max(x)-min(x))*minPts*gamma(.5*n+1))/(m*sqrt(pi.^n))).^(1/n);

if nargin==3
	dist_metric='euclidean';
end;

%zmienne i stale
vectors_count=size(X,2);

minPts=minPts-1;

NOISE_LABEL=0;

NOT_VISITED_FLAG=-2;
NOISE_FLAG=-1;
BORDER_FLAG=0;
CORE_FLAG=1;

labels=zeros(1,vectors_count);
flag=NOT_VISITED_FLAG*ones(1,vectors_count);

%macierz odleglosci
%d=cluster_distmtx(X,dist_metric);
d=pdist(X',dist_metric);
d=squareform(d);

%listy sasiadow w otoczeniu o promieniu Eps
nn=cell(vectors_count,1);
for i=1:vectors_count
    if isinf(Eps)
        nn{i}=1:vectors_count;
        nn{i}(i)=[];
    else
        d(i,i)=Inf;
        nn{i}=find(d(i,:)<=Eps);
    end
end;

%glowna petla algorytmu
cluster_id=0;
for i=1:vectors_count
	if flag(i)==NOT_VISITED_FLAG
		seeds=nn{i};
		if length(seeds)<minPts
			flag(i)=NOISE_FLAG;
			labels(i)=NOISE_LABEL;
		else
			flag(i)=CORE_FLAG;
			cluster_id=cluster_id+1;        %nieodwiedzony punkt CORE => nowy klaster
			labels(i)=cluster_id;

			while ~isempty(seeds)
				seed=seeds(1);
				labels(seed)=cluster_id;  %kazdy punkt w otoczeniu staje sie czescia klastra

				points=nn{seed};

				if length(points)>=minPts
					flag(seed)=CORE_FLAG;
					for k=1:length(points)
						point=points(k);
						if flag(point)==NOT_VISITED_FLAG || flag(point)==NOISE_FLAG
							if flag(point)==NOT_VISITED_FLAG
								if isempty(find(seeds==point))
									seeds(end+1)=point;
								end;
								%flag(point)=BORDER;
							end;
							labels(point)=cluster_id;
						end;
					end;
				else
					flag(seed)=BORDER_FLAG;
				end;
				seeds(1)=[];
			end;
		end;
	end;
end;
