function d=cluster_distance(x,data,distance_metric,sqroot)

%data=[x,data];
dimension=size(data,1);
vectors_count=size(data,2);

switch distance_metric
	case {'euclidean','sqEuclidean'}
		data=(data-repmat(x,1,vectors_count)).^2;
		d=sum(data);
		if sqroot==1
			d=sqrt(d);
		end;

	case 'seuclidean'
		if vectors_count>1
			w=repmat(var(data')',1,vectors_count);
			data=((data-repmat(x,1,vectors_count)).^2)./w;
		else
			data=(data-repmat(x,1,vectors_count)).^2;
		end;
		d=sum(data);
		if sqroot==1
			d=sqrt(d);
		end;

	case 'mahalanobis'
		if vectors_count>1
			w=inv(cov(data'));
			data=(data-repmat(x,1,vectors_count))';
%			for i=1:vectors_count
%				d(i)=data(:,i)'*w*data(:,i);
%			end;
			d=sum((data*w).*data,2)';
		else
			data=(data-repmat(x,1,vectors_count)).^2;
			d=sum(data,2);
		end;
		if sqroot==1
			d=sqrt(d);
		end;

	case 'correlation'
		data=(data-repmat(mean(data),dimension,1));
		data=data./repmat(sqrt(sum(data.^2)),dimension,1);

		x=x-mean(x);
		x=repmat(x./sqrt(sum(x.^2)),1,vectors_count);
		
		d=1-sum(x.*data);

	case 'cosine'
		data=data./repmat(sqrt(sum(data.^2)),dimension,1);
		x=repmat(x./sqrt(sum(x.^2)),1,vectors_count);
		
		d=1-sum(x.*data);

	case 'spearman'
		d=1-spear(x,data);

	case 'cityblock'
		data=abs(data-repmat(x,1,vectors_count));
		d=sum(data);

	case 'chebychev'
		data=abs(data-repmat(x,1,vectors_count));
		d=max(data);
end;