function order=cluster_jp(data,k,l,dist_metric,klt);

if nargin<3
	error('Brak danych wejciowych');
end;

if nargin==3
	dist_metric='euclidean';
	klt=0;
end;

if nargin==3
	klt=0;
end;

dimension=size(data,1);
vectors_count=size(data,2);
if klt~=0
	org_data=data;
	data=data-repmat(mean(data,2),1,vectors_count);
	[u,s,v]=svd(data,0);
	data=s(1:klt,1:klt)*v(:,1:klt)';
end;

neighbours=zeros(vectors_count,k+1);
order=1:vectors_count;

dist_mtx=pdist(data',dist_metric);
for i=1:vectors_count
	d=zeros(1,vectors_count);
	for j=1:vectors_count
		d(j)=cluster_pdist2dist(dist_mtx,i,j,vectors_count);
	end;
	[d,index]=sort(d);
	neighbours(i,:)=index(1:k+1);
end;
neighbours(:,1)=[];

not_joined=1:vectors_count;
while ~isempty(not_joined)
	for i=2:length(not_joined)
		if ~isempty(find(neighbours(not_joined(i),:)==not_joined(1))) & ~isempty(find(neighbours(not_joined(1),:)==not_joined(i))) & length(intersect(neighbours(not_joined(1),:),neighbours(not_joined(i),:)))>=l
			order(not_joined(i))=not_joined(1);
		end;
	end;
	index=find(order(not_joined)==order(not_joined(1)));
	not_joined(index)=[];
end;
order=cluster_reorder(order);
return;


function d=cluster_pdist2dist(dist_mtx,y,x,n);

if x==y
	d=0;
else
	i=min(x,y);
	j=max(x,y);

	d=dist_mtx((i-1)*(n-i/2)+j-i);
end;