function [cd,rd,order]=cluster_optics(X,minPts,Eps,dist_metric)

%TODO sprawdzic dokladnie dzialanie dla Eps = Inf

if nargin<4
	dist_metric='euclidean';
end;

%zmienne
minPts=minPts-1;

vectors_count=size(X,2);

order=[];
cd=Inf*ones(1,vectors_count);
rd=Inf*ones(1,vectors_count);
processed=zeros(1,vectors_count);

%TODO distmtx
%macierz odleglosci
d=pdist(X',dist_metric);
d=squareform(d);

%listy sasiadow w otoczeniu o promienu Eps
nn=cell(vectors_count,1);
for i=1:vectors_count
    if isinf(Eps)
        nn{i}=1:vectors_count;
        nn{i}(i)=[];
    else
        d(i,i)=Inf;
        nn{i}=find(d(i,:)<=Eps);
    end
end;

%wyznaczanie core dist
for i=1:vectors_count
    if length(nn{i})>=minPts
        [dnn,idx]=sort(d(i,nn{i}));
        cd(i)=dnn(minPts);
        %nn{i}=nn{i}(idx);
    end;
end;

%glowna petla algorytmu
for i=1:vectors_count
    if processed(i)~=1 
        processed(i)=1;
        order=[order i];
        
        if ~isinf(cd(i))
            seeds=[];
            [seeds,rd]=update(seeds,rd,processed,d,i,cd(i),nn{i});
            
            %seeds
            %sedds_rd=rd(seeds)
            
            while ~isempty(seeds)
                [ii,next_seed]=min(rd(seeds));
                               
                %seeds
                %sedds_rd=rd(seeds)
                %next_seed
                
                j=seeds(next_seed);
                seeds(next_seed)=[];
                
                processed(j)=1;
                order=[order j];
        
                if ~isinf(cd(j))
                    [seeds,rd]=update(seeds,rd,processed,d,j,cd(j),nn{j});
                end
            end
        end
    end
end
return;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [seeds,rd]=update(seeds,rd,flag,d,c_idx,c_dist,neighbors)

for i=1:length(neighbors)
    idx=neighbors(i);
    if (flag(idx)~=1)
        r_dist=max(c_dist,d(c_idx,idx));
        
        if isinf(rd(idx))
            rd(idx)=r_dist;
            seeds=[seeds idx];
        else
            if r_dist<rd(idx)
                rd(idx)=r_dist;                    
            end
        end;
    end;
end;
return;