function [centroids,dispersion]=cluster_ord2centr(data,order,centroid_type,dist_metric,sqroot)

dimension=size(data,1);
clusters_count=max(order);

centroids=zeros(dimension,clusters_count);
dispersion=0;

for i=1:clusters_count
	cluster_vectors_list=find(order==i);
	
	if ~isempty(cluster_vectors_list)
		switch centroid_type
			case 'kmeans'
				centroids(:,i)=mean(data(:,cluster_vectors_list),2);
			case 'kmedians'
				centroids(:,i)=median(data(:,cluster_vectors_list),2);
		end;
		dispersion=dispersion+sum(cluster_distance(centroids(:,i),data(:,cluster_vectors_list),dist_metric,sqroot));
	end;
end;
return;
