function [adj_data,list]=data_adjust(data,min_val,max_val,changed_count,change2nan,logarithm);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Spawdzenie paramtrw wejciowych%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~exist('data')
	error('Brak danych wejciowych');
end;
if ~exist('min_val') | ~exist('min_val')
	error('Niepoprawny zakres');
end;
if ~exist('change2nan') 
	change2nan=0;
end;
if ~exist('changed_count')
	changed_count=1;
end;
if ~exist('logarithm')
	logarithm=0;
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

vectors_nr=size(data,2);
adj_data=data;
list=[];

if change2nan==1
	adj_data(find(adj_data<min_val))=Inf;
	adj_data(find(adj_data>max_val))=Inf;
	missing=isinf(adj_data);
	list=find(sum(missing,2)>changed_count);
	adj_data(find(missing==1))=NaN;
else
	adj_data(find(adj_data<min_val))=Inf;
	missing=isinf(adj_data);
	list=find(sum(missing,2)>changed_count);
	adj_data(find(missing==1))=min_val;

	adj_data(find(adj_data>max_val))=Inf;
	missing=isinf(adj_data);
	list=sort([list ; find(sum(missing,2)>changed_count)]);
	adj_data(find(missing==1))=max_val;
end;
adj_data(list,:)=[];

if logarithm~=0 
	switch logarithm
		case 1
			adj_data(find(adj_data<=0))=1;
			adj_data=log2(adj_data);
		case 2
			adj_data(find(adj_data<=0))=1;
			adj_data=log10(adj_data);
		case 3
			adj_data(find(adj_data<=0))=1;
			adj_data=log(adj_data);
		case 4
			adj_data=2.^(adj_data);
		case 5
			adj_data=10.^(adj_data);
		case 6
			adj_data=exp(adj_data);
	end;
end;