function [coeffs,norm_data]=data_arraynorm(data,hkg_list,method,coeffnorm);

if nargin==1
	hkg_list=1:size(data,1);
	method='lrega';
	coeffnorm=0;
end;
if nargin==2
	if isempty(hkg_list) | min(size(hkg_list))~=1
		hkg_list=1:size(data,1);
	end;
	method='lrega';
	coeffnorm=0;
end;
if nargin==3
	if isempty(hkg_list) | min(size(hkg_list))~=1
		hkg_list=1:size(data,1);
	end;
	if isempty(method) 
		method='lrega';
	end;
	coeffnorm=0;
end;
if nargin==4
	if isempty(hkg_list) | min(size(hkg_list))~=1
		hkg_list=1:size(data,1);
	end;
	if isempty(method) 
		method='lrega';
	end;
	if isempty(coeffnorm) 
		coeffnorm=0;
	end;
end;

dimension=size(data,1);
vectors_count=size(data,2);

a=[];
b=[];
switch method
	case 'smean'
		if max(size(hkg_list))==1
			b=data(hkg_list,:);
		else
			if ~isempty(find(isnan(data(hkg_list,:))==1))
				b=nan_mean(data(hkg_list,:),1);
			else
				b=mean(data(hkg_list,:));
			end;
		end;
		if ~isempty(find(isnan(b)==1))
			b=zeros(1,size(data,2));
		end;
		if coeffnorm==1
			b=b-min(b);
		end;

	case 'smedian'
		if max(size(hkg_list))==1
			b=data(hkg_list,:);
		else
			if ~isempty(find(isnan(data(hkg_list,:))==1))
				b=nan_median(data(hkg_list,:),1);
			else
				b=median(data(hkg_list,:));
			end;
		end;
		if ~isempty(find(isnan(b)==1))
			b=zeros(1,size(data,2));
		end;
		if coeffnorm==1
			b=b-min(b);
		end;
	
	case 'dsum'
		if max(size(hkg_list))==1
			a=1./data(hkg_list,:);
		else
			if ~isempty(find(isnan(data(hkg_list,:))==1))
				a=1./nan_sum(data(hkg_list,:),1);
			else
				a=1./sum(data(hkg_list,:));
			end;
		end;
		if ~isempty(find(isnan(a)==1))
			a=ones(1,size(data,2));
		end;
		if coeffnorm==1
			a=a./max(a);
		end;
		
	case 'dmean'
		if max(size(hkg_list))==1
			a=1./data(hkg_list,:);
		else
			if ~isempty(find(isnan(data(hkg_list,:))==1))
				a=1./nan_mean(data(hkg_list,:),1);
			else
				a=1./mean(data(hkg_list,:));
			end;
		end;
		if ~isempty(find(isnan(a)==1))
			a=ones(1,size(data,2));
		end;
		if coeffnorm==1
			a=a./max(a);
		end;
		
	case 'tmean'
		if max(size(hkg_list))==1
			a=1./data(hkg_list,:);
		else
			if ~isempty(find(isnan(data(hkg_list,:))==1))
				a=1./nan_trimmean(data(hkg_list,:),4,1);
			else
				a=1./trimmean(data(hkg_list,:),4);
			end;
		end;
		if ~isempty(find(isnan(a)==1))
			a=ones(1,size(data,2));
		end;
		if coeffnorm==1
			a=a./max(a);
		end;

	case 'dgmean'
		if max(size(hkg_list))==1
			a=1./data(hkg_list,:);
		else
			if ~isempty(find(isnan(data(hkg_list,:))==1))
				a=1./nan_gmean(data(hkg_list,:),1);
			else
				a=1./gmean(data(hkg_list,:));	
			end;
		end;
		if ~isempty(find(isnan(a)==1))
			a=ones(1,size(data,2));
		end;
		if coeffnorm==1
			a=a./max(a);
		end;

	case 'dmedian'
		if max(size(hkg_list))==1
			a=1./data(hkg_list,:);
		else
			if ~isempty(find(isnan(data(hkg_list,:))==1))
				a=1./nan_median(data(hkg_list,:),1);
			else
				a=1./median(data(hkg_list,:));
			end;
		end;
		if ~isempty(find(isnan(a)==1))
			a=ones(1,size(data,2));
		end;
		if coeffnorm==1
			a=a./max(a);
		end;
		
	case 'lreg_a'
		a=ones(1,vectors_count);
		for i=2:vectors_count
			a(i)=regress(data(hkg_list,i),data(hkg_list,1));
		end;
		a=1./a;
		if coeffnorm==1
			a=a./max(a);
		end;
		
	case 'lreg_ab'
		a=ones(1,vectors_count);
		b=zeros(1,vectors_count);
		for i=2:vectors_count
			n=regress(data(hkg_list,i),[data(hkg_list,1) ones(length(hkg_list),1)]);
			a(i)=1/n(1);
			b(i)=n(2);
		end;

	case 'lreg_ls'
		b=mean(data(hkg_list,:));
		[u,s,v]=svd(data(hkg_list,:)-repmat(mean(data(hkg_list,:),2),1,vectors_count));
		a=s(1,1)*v(:,1);
end;

if nargout>1
	norm_data=data;
	if ~isempty(b)
		norm_data=norm_data-repmat(b,dimension,1);
	end;
	if ~isempty(a)
		norm_data=repmat(a,dimension,1).*norm_data;
	end;
end;

if isempty(a)
	a=ones(1,vectors_count);
end;
if isempty(b)
	b=zeros(1,vectors_count);
end;
coeffs=[a;b];