function [denoised_data,u,s,v]=data_denoise(data,eigen_nr,u,v,s);

if nargin<1
	error('The function needs al least one argument');
end;
if nargin==1
	eigen_nr=0.9;
	u=[];
	v=[];
	s=[];
end;
if nargin==2
	u=[];
	v=[];
	s=[];
end;
if nargin==3
	v=[];
	s=[];
end;
if nargin==4
	s=[];
end;

vectors_nr=size(data,2);
m=repmat(mean(data,2),1,vectors_nr);
data=data-m;

if isempty(u) | isempty(v) | isempty(s)
	[u,s,v]=svd(data,0);
end;

if eigen_nr<1
	[e,p,eigen_nr]=svd_entropy(data,0,eigen_nr,s);
else
	eigen_nr=min(eigen_nr,size(data,2));
end;

denoised_data=u(:,1:eigen_nr)*s(1:eigen_nr,1:eigen_nr)*v(:,1:eigen_nr)'+m;

%ds=diag(s);
%ds(eigen_nr+1:length(ds))=0;
%s=diag(ds);
%denoised_data=u*s*v'+m;


