function adjust;

size_x=250;
size_y=270;
logarithm_string=[	'log_2 ';
			'log_10';
			'log_e ';
			'exp_2 ';
			'exp_10';
			'exp_e '];

Adjust_id=findobj('Tag','Adjust');
if isempty(Adjust_id)==0
	figure(Adjust_id);
else
	Array_id=findobj(get(0,'Child'),'Tag','ArrayView');

	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

	set(Array_id,'Pointer','watch');

	data=get(Array_id,'UserData');
	vectors_count=size(data,2);
	min_val=min2(data);
	max_val=max2(data);
	std_val=nan_sd(data(:));
	mean_val=nan_mean(data(:));
	if abs(mean_val)<=5*eps
		mean_val=0;
	end;

	if min_val<=0
		LogCheck_enable='off';
	else
		LogCheck_enable='on';
	end;
	clear data;

	set(Array_id,'Pointer','arrow');

	Adjust_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','Zmiana zakresu wartoci', ...
		'KeyPressFcn',@figure_kb_cb,...
		'Tag','Adjust');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 175 240 87], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','InfoFrame');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 251 60 18], ...
		'HorizontalAlignment','left', ...
		'String',' Informacje: ', ...
		'Style','text', ...
		'Tag','InfoText');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 230 90 18], ...
		'String','Zakres wartoci:',...
		'Style','text', ...
		'Tag','RangeText');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[100 230 60 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(min_val),...
		'Style','edit', ...
		'Enable','off',...
		'Tag','RangeMinEdit');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[160 230 15 18], ...
		'HorizontalAlignment','center', ...
		'String','-',...
		'Style','text', ...
		'Tag','RangeSeparatorText');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[175 230 60 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(max_val),...
		'Style','edit', ...
		'Enable','off',...
		'Tag','RangeMaxEdit');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 205 90 18], ...
		'String','Warto rednia:',...
		'Style','text', ...
		'Tag','MeanText');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[100 205 60 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(mean_val),...
		'Style','edit', ...
		'Enable','off',...
		'Tag','MeanEdit');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 180 90 18], ...
		'String','Odchylenie std.:',...
		'Style','text', ...
		'Tag','StdText');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[100 180 60 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(std_val),...
		'Style','edit', ...
		'Enable','off',...
		'Tag','StdEdit');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'Position',[175 180 60 20], ...
		'String','Histogram', ...
		'Tag','HistogramButt', ...
		'CallBack','plot_hist');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 240 130], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','DataFrame');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 154 60 18], ...
		'HorizontalAlignment','left', ...
		'String',' Parametry: ', ...
		'Style','text', ...
		'Tag','DataText');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 130 90 18], ...
		'String','Nowy zakres:',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','NewRangeCheck',...
		'Callback','adjust_cb(''check'')');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[100 130 60 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(min_val),...
		'UserData',[min_val max_val min_val 0],...
		'Style','edit', ...
		'Enable','off',...
		'Tag','NewRangeMinEdit',...
		'Callback','adjust_cb(''edit'')');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[160 130 15 18], ...
		'HorizontalAlignment','center', ...
		'String','-',...
		'Style','text', ...
		'Tag','NewRangeSeparatorText');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[175 130 60 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(max_val),...
		'UserData',[min_val max_val max_val 0],...
		'Style','edit', ...
		'Enable','off',...
		'Tag','NewRangeMaxEdit',...
		'Callback','adjust_cb(''edit'')');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[175 100 60 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(vectors_count),...
		'UserData',[1 vectors_count vectors_count 0],...
		'Style','edit', ...
		'Enable','off',...
		'Tag','FilterEdit',...
		'Callback','adjust_cb(''edit'')');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[15 99 160 18], ...
		'HorizontalAlignment','left', ...
		'String','Max. zmienionych w wierszu:', ...
		'Enable','off',...
		'Style','text', ...
		'Tag','FilterEditText');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[15 75 200 18], ...
		'String','Zamiana na brakujce wartoci',...
		'Style','checkbox', ...
		'Value',0,...
		'Enable','off',...
		'Tag','NaNCheck',...
		'Callback','');
	
	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 45 120 18], ...
		'String','Zamiana skali na:',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','LogarithmCheck',...
		'Callback','adjust_cb(''check'')');

%		'Enable',LogCheck_enable,...

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[135 45 100 20], ...
		'String',logarithm_string, ...
		'Style','popupmenu',...
		'Value',1, ...	
		'Enable','off',...
		'Tag','LogarithmPop', ...
		'Callback','');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'Position',[165 5 80 25], ...
		'String','Wykonaj', ...
		'Tag','AdjustButt', ...
		'CallBack','adjust_cb(''adjust'')');

	uicontrol('Parent',Adjust_id, ...
		'Units','pixels', ...
		'Position',[80 5 80 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
		'Callback','delete(gcbf);');
end;