function adjust_cb(action);

Adjust_id=findobj(0,'Tag','Adjust');
RangeCheck_id=findobj(Adjust_id,'Tag','NewRangeCheck');
RangeMinEdit_id=findobj(Adjust_id,'Tag','NewRangeMinEdit');
RangeMaxEdit_id=findobj(Adjust_id,'Tag','NewRangeMaxEdit');
LogarithmCheck_id=findobj(Adjust_id,'Tag','LogarithmCheck');
NaNCheck_id=findobj(Adjust_id,'Tag','NaNCheck');
FilterEdit_id=findobj(Adjust_id,'Tag','FilterEdit');
LogarithmPop_id=findobj(Adjust_id,'Tag','LogarithmPop');

switch action
	case 'edit'
		Edit_id=gcbo;
		num=str2num(get(Edit_id,'String'));
		limits=get(Edit_id,'UserData');

		if isempty(num)==1
			num=limits(3);
			beep;
		else
			switch limits(4)
				case 0
					if num<limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
				case 1
					if num<=limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 2
					if num<limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 3
					if num<=limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
			end;
		end;
		set(Edit_id,'String',num2str(num));

	case 'check'
		if get(RangeCheck_id,'Value')==1
			set(RangeMinEdit_id,'Enable','on');
			set(RangeMaxEdit_id,'Enable','on');
			set(FilterEdit_id,'Enable','on');
			set(findobj(Adjust_id,'Tag','FilterEditText'),'Enable','on');
			set(NaNCheck_id,'Enable','on');
		else
			set(RangeMinEdit_id,'Enable','off');
			set(RangeMaxEdit_id,'Enable','off');
			set(findobj(Adjust_id,'Tag','FilterEditText'),'Enable','off');
			set(FilterEdit_id,'Enable','off');
			set(NaNCheck_id,'Enable','off');
		end;
		if get(LogarithmCheck_id,'Value')==1
			set(LogarithmPop_id,'Enable','on');
		else
			set(LogarithmPop_id,'Enable','off');
		end;

	case 'adjust'
		Array_id=findobj(get(0,'Child'),'Tag','ArrayView');
		set(Array_id,'Pointer','watch');
		data=get(Array_id,'UserData');
		pause(0.01);

		if get(RangeCheck_id,'Value')==1 
			min_val=str2num(get(RangeMinEdit_id,'String'));
			max_val=str2num(get(RangeMaxEdit_id,'String'));
			if max_val<=min_val
				set(Array_id,'Pointer','arrow');
				beep;
				return;
			end;
			changed_count=str2num(get(FilterEdit_id,'String'));

			if get(LogarithmCheck_id,'Value')==1
				[data,list]=data_adjust(data,min_val,max_val,changed_count,get(NaNCheck_id,'Value'),get(LogarithmPop_id,'Value'));
			else
				[data,list]=data_adjust(data,min_val,max_val,changed_count,get(NaNCheck_id,'Value'),0);
			end;
			
			gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
			gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
			glist=get(findobj(Array_id,'Tag','DatasetPanel'),'UserData');
			stat_struct=get(findobj(Array_id,'Tag','Select1D'),'UserData');

			gnames(list,:)=[];
			gorder(list)=[];
			glist(list)=[];
			stat_struct.fc(list)=[];
			stat_struct.pval(list)=[];
			stat_struct.fdr(list)=[];
			stat_struct.n(list)=[];

			set(findobj(Array_id,'Tag','GeneClassAxes'),'UserData',gorder);
			set(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData',gnames);
			set(findobj(Array_id,'Tag','DatasetPanel'),'UserData',glist);
			set(findobj(Array_id,'Tag','Select1D'),'UserData',stat_struct);
		else
			if get(LogarithmCheck_id,'Value')==1
				current_min=str2num(get(RangeMinEdit_id,'String'))-1;
				current_max=str2num(get(RangeMaxEdit_id,'String'))+1;
				[data,list]=data_adjust(data,current_min,current_max,1,0,get(LogarithmPop_id,'Value'));
			end;
		end;
	
		set(Array_id,'UserData',data);

%		if get(NaNCheck_id,'Value')==1
			missing_info=zeros(1,2);
			[missing_info(1),missing_info(2)]=missing_percent(data);
			missing_info(2)=size(data,1)-missing_info(2);
			set(findobj(Array_id,'Tag','ValueEdit'),'UserData',missing_info);
%		end;

		mstat_cb('reset_selection');
		mstat_cb('do_gui');
		mstat_cb('do_menu');
		mstat_cb('prepare_data');
		mstat_cb('prepare_axis');
		mstat_cb('redraw');

		set(Array_id,'Pointer','arrow');
		delete(Adjust_id);
end;
