function denoise();

size_x=400;
size_y=220;

Denoise_id=findobj('Tag','Denoise');
if isempty(Denoise_id)==0
	figure(Denoise_id);
else
	Array_id=findobj(0,'Tag','ArrayView');
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

	set(Array_id,'Pointer','watch');
	pause(0.01);

	data=get(Array_id,'UserData');
	data=data_center(data,'mean');

	[u,s,v]=svd(data,0);
	[enthropy,p,nr]=svd_entropy([],0,0.9,s);
	set(Array_id,'Pointer','arrow');

	eigengene_count=min(size(data,1),size(data,2));
	pc_string=cell(1,eigengene_count);
	for i=1:eigengene_count
		pc_string{i}=num2str(i);
	end;

	Denoise_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','Odszumianie', ...
		'KeyPressFcn',@figure_kb_cb,...		
		'Tag','Denoise');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 120 390 90], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','InfoFrame');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 199 60 18], ...
		'HorizontalAlignment','left', ...
		'String',' Informacje: ', ...
		'Style','text', ...
		'Tag','InfoText');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 175 70 20], ...
		'HorizontalAlignment','right', ...
   		'String',num2str(enthropy),...
		'Style','edit', ...
		'Enable','off',...
		'Tag','EnthropyEdit');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 175 90 18], ...
		'HorizontalAlignment','left', ...
		'String','Entropia zbioru:',...
		'Style','text', ...
		'Tag','EnthropyEditText');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
	   	'Position',[210 175 180 20], ...
		'String','Wywietl wzgldny udzia', ...
		'Tag','ExpressionButt', ...
		'CallBack','denoise_cb(''expression'')');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 150 70 20], ...
		'HorizontalAlignment','right', ...
		'UserData',[1 100 80 3],...
   		'String','90',...
		'Style','edit', ...
		'Enable','on',...
		'Tag','PercentEdit',...
		'Callback','denoise_cb(''edit'')');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 150 120 18], ...
		'HorizontalAlignment','left', ...
		'String','Skadowe zawierajce',...
		'Style','text', ...
		'Tag','PercentEditText');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[275 150 40 20], ...
		'HorizontalAlignment','right', ...
	   	'String',num2str(nr),...
		'Style','edit', ...
		'Enable','off',...
		'Tag','PercentEdit2',...
		'Callback','');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[210 150 60 18], ...
		'HorizontalAlignment','left', ...
		'String','% wariancji:',...
		'Style','text', ...
		'Tag','PercentEditText2');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
	   	'Position',[320 150 70 20], ...
		'String','Wyznacz', ...
		'Tag','PercentButt', ...
		'CallBack','denoise_cb(''percent'')');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 125 70 20], ...
		'String',pc_string, ...
		'Style','popupmenu',...
		'Value',1, ...
		'Tag','ProfilePop', ...
		'Callback','');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 125 120 18], ...
		'HorizontalAlignment','left', ...
		'String','Numer skadowej:',...
		'Style','text', ...
		'Tag','ProfileEditText');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
	   	'Position',[210 125 180 20], ...
		'String','Wywietl profil', ...
		'Tag','ProfileButt', ...
		'CallBack','denoise_cb(''profile'')');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 390 75], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','DenoiseFrame');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 99 65 18], ...
		'HorizontalAlignment','left', ...
		'String',' Ustawienia: ', ...
		'Style','text', ...
		'Tag','DenoiseText');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 75 70 20], ...
		'HorizontalAlignment','right', ...
		'UserData',[1 size(s,2)-1 nr 0],...
		'String',nr,...
		'Style','edit', ...
		'Enable','on',...
		'Tag','EigenNrEdit',...
		'Callback','denoise_cb(''edit'')');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 75 120 18], ...
		'HorizontalAlignment','left', ...
		'String','Liczba skadowych:',...
		'Style','text', ...
		'Tag','EigenNrEditText');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
	   	'Position',[230 5 80 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
		'Callback','delete(gcbf);');

	uicontrol('Parent',Denoise_id, ...
		'Units','pixels', ...
	   	'Position',[315 5 80 25], ...
		'String','Wykonaj', ...
		'Tag','DeleteButt', ...
		'CallBack','denoise_cb(''denoise'')');

	data_struct.u=u;
	data_struct.s=s;
	data_struct.v=v;
	data_struct.eigengene_nr=1;
	set(Denoise_id,'UserData',data_struct);
end;

