function filter_arrays;

size_x=285;
size_y=125;

Array_id=findobj('Tag','ArrayView');
config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
max_group_size=0;
for i=1:max(gorder)
	index=find(gorder==i);
	if length(index)>max_group_size
		max_group_size=length(index);
	end;
end;

Filter_id=findobj('Tag','FilterGroups');
if ~isempty(Filter_id)
	figure(Filter_id);
else
	Filter_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','Filtracja grup cech', ...
		'KeyPressFcn',@figure_kb_cb,...
		'Tag','FilterGroups');

	hnd=uipanel('Parent',Filter_id, ...
		'Title','Parametry:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 280 90], ...
		'Tag','FilterPanel');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 55 200 18], ...
		'String','Pozostaw grupy majce co najmniej:',...
		'Style','radio', ...
		'Value',1,...
		'Tag','DelSmallRadio',...
		'Callback','filter_groups_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[220 55 50 20], ...
		'HorizontalAlignment','right', ...
		'String','2',...
		'Style','edit', ...
		'Enable','on',...
		'UserData',[2 max_group_size 2 2],...
		'Tag','DelSmallEdit',...
		'Callback','filter_groups_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 30 120 18], ...
		'String','Usu grupy z listy',...
		'Style','radio', ...
		'Value',0,...
		'Tag','DelListRadio',...
		'Callback','filter_groups_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 5 130 18], ...
		'String','Pozostaw grupy z listy',...
		'Style','radio', ...
		'Value',0,...
		'Tag','KeepListRadio',...
		'Callback','filter_groups_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'Position',[155 5 115 20], ...
		'String','Wczytaj list grup', ...
		'Tag','ListButt', ...
		'Enable','off',...
		'CallBack','filter_groups_cb(''load_list'')');

	uicontrol('Parent',Filter_id, ...
		'Units','pixels', ...
		'Position',[205 5 80 25], ...
		'String','Wykonaj', ...
		'Tag','FilterButt', ...
		'CallBack','filter_groups_cb(''filter'')');

	uicontrol('Parent',Filter_id, ...
		'Units','pixels', ...
		'Position',[120 5 80 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
		'Callback','delete(gcbf)');
end;
