function filter_genes_cb(action);

Array_id=findobj('Tag','ArrayView');
Filter_id=findobj('Tag','FilterGroups');
RadioHnd_id=findobj(Filter_id,'Style','radio');
radios_nr=length(RadioHnd_id);
DelSmallEdit_id=findobj(Filter_id,'Tag','DelSmallEdit');
ListButt_id=findobj(Filter_id,'Tag','ListButt');

config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

switch action
	case 'edit'
		Edit_id=gcbo;
		num=str2num(get(Edit_id,'String'));
		limits=get(Edit_id,'UserData');

		if isempty(num)==1
			num=limits(3);
			beep;
		else
			switch limits(4)
				case 0
					if num<limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
				case 1
					if num<=limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 2
					if num<limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 3
					if num<=limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
			end;
		end;
		set(Edit_id,'String',num2str(num));

	case 'radio'
		CurrentRadio_id=gcbo;
		for i=1:radios_nr
			if (RadioHnd_id(i)~=CurrentRadio_id)
				set(RadioHnd_id(i),'Value',0);
			else
				set(RadioHnd_id(i),'Value',1);
				method=radios_nr-i+1;
			end;
		end;

		switch method
			case 1
				set(ListButt_id,'Enable','off');
				set(DelSmallEdit_id,'Enable','on');
			case {2,3}
				set(ListButt_id,'Enable','on');
				set(DelSmallEdit_id,'Enable','off');
		end;

	case 'load_list'
		[fname,path]=uigetfile({'*.gcn','Nazwy grup (*.gcn)'; '*.*','Wszystkie pliki'},'Otwrz plik',config.open_path);
		file=[path,fname];
		if file~=0
			user_list=load_cell(file);
			if ~isempty(user_list) & min(size(user_list))==1
				set(Filter_id,'UserData',user_list);
			end;
		end;

	case 'filter'
		set(Filter_id,'Pointer','watch');
		data=get(Array_id,'UserData');
		image_data=get(findobj(Array_id,'Tag','ArrayAxes'),'UserData');
		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
		gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
		gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
		stat_struct=get(findobj(Array_id,'Tag','Select1D'),'UserData');
		glist=get(findobj(Array_id,'Tag','DatasetPanel'),'UserData');

		for i=1:radios_nr
			if get(RadioHnd_id(i),'Value')==1
				method=radios_nr-i+1;
				break;
			end;
		end;

		switch method

		case 1
			min_size=str2num(get(DelSmallEdit_id,'String'));
			list=[];
			for i=1:length(gcnames)
				index=find(gorder==i);
				if ~isempty(index)
					if length(index)<min_size
						list=[list;index];
					end;
				end;
			end;

			data(list,:)=[];
			image_data(list,:)=[];
			gnames(list)=[];
			gorder(list)=[];
			glist(list)=[];
			stat_struct.fc(list)=[];
			stat_struct.pval(list)=[];
			stat_struct.fdr(list)=[];
			stat_struct.n(list)=[];
			
		otherwise
			user_list=get(Filter_id,'UserData');
			if ~isempty(user_list)
				index=name2index(user_list,gcnames);
				list=[];
				for i=1:length(index)
					list=[list;find(gorder==index(i))];
				end;

				if method==2
					data(list,:)=[];
					image_data(list,:)=[];
					gnames(list)=[];
					gorder(list)=[];
					glist(list)=[];
					stat_struct.fc(list)=[];
					stat_struct.pval(list)=[];
					stat_struct.fdr(list)=[];
					stat_struct.n(list)=[];
				else
					data=data(list,:);
					image_data=image_data(list,:);
					gnames=gnames(list);
					gorder=gorder(list);
					glist=glist(list);
					stat_struct.fc=stat_struct.fc(list);
					stat_struct.pval=stat_struct.pval(list);
					stat_struct.fdr=stat_struct.fdr(list);
					stat_struct.n=stat_struct.n(list);
				end;
			else
				beep;
				warndlg('Lista grup nie zostaa wczytana','MStat');
				set(Filter_id,'Pointer','arrow');
				return;
			end;
		end;

		if isempty(data)
			beep;
			warndlg('Usunite wszystkie cechy','MStat');
			set(Filter_id,'Pointer','arrow');
			return;
		else
			switch questdlg(sprintf('Liczba cech po filtacji: %d',size(data,1)),'MStat','Akceptuj','Anuluj','Akceptuj')
				case 'Anuluj'
					set(Filter_id,'Pointer','arrow');
					return;
				case 'Akceptuj'
					clist=1:length(gcnames);
					gcnames=gcnames(clist(unique(gorder)));
					gorder=reorder_labels(gorder);

					set(Array_id,'UserData',data);
					set(findobj(Array_id,'Tag','ArrayAxes'),'UserData',image_data);
					set(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData',gnames);
					set(findobj(Array_id,'Tag','GeneClassAxes'),'UserData',gorder);
					set(findobj(Array_id,'Tag','GeneClassPop'),'Value',1,'UserData',gcnames);
					set(findobj(Array_id,'Tag','Select1D'),'UserData',stat_struct);
					set(findobj(Array_id,'Tag','DatasetPanel'),'UserData',glist);

					mstat_cb('reset_selection');
					mstat_cb('do_gui');
					mstat_cb('prepare_axis');
					mstat_cb('redraw');

					%aktualizacja tabel
					GeneTable_id=findobj('Tag','GeneTable');
					if ~isempty(GeneTable_id)
						genes_table('create')
					end;
					ValueTable_id=findobj('Tag','ValueTable');
					if ~isempty(ValueTable_id)
						values_table('create')
					end;
					GroupTable_id=findobj('Tag','GroupTable');
					if ~isempty(GroupTable_id)
						groups_table('create')
					end;
					
					set(Filter_id,'Pointer','arrow');
					delete(Filter_id);
			end;
		end;
end;
