function svdec_cb(action);

Array_id=findobj(0,'Tag','ArrayView');
ICA_id=findobj(0,'Tag','ICA');

PCEdit_id=findobj(ICA_id,'Tag','PCEdit');
GeneCenterCheck_id=findobj(ICA_id,'Tag','GeneCenterCheck');
ArrayCenterCheck_id=findobj(ICA_id,'Tag','ArrayCenterCheck');
GeneStdCheck_id=findobj(ICA_id,'Tag','GeneStdCheck');

ICAStabilizationCheck_id=findobj(ICA_id,'Tag','ICAStabilizationCheck');
ICARandGenCheck_id=findobj(ICA_id,'Tag','ICARandGenCheck');

ProfilePop_id=findobj(ICA_id,'Tag','ProfilePop');
ProfilePopText_id=findobj(ICA_id,'Tag','ProfilePopText');
ProfileButt_id=findobj(ICA_id,'Tag','ProfileButt');

SaveButt_id=findobj(ICA_id,'Tag','SaveButt');

switch action
	case 'edit'
		Edit_id=gcbo;
		num=str2num(get(Edit_id,'String'));
		limits=get(Edit_id,'UserData');

		if isempty(num)==1
			num=limits(3);
			beep;
		else
			switch limits(4)
				case 0
					if num<limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
				case 1
					if num<=limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 2
					if num<limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 3
					if num<=limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
			end;
		end;
		set(Edit_id,'String',num2str(num));

	case 'pop'
		data_struct=get(ICA_id,'UserData');
		data_struct.component_nr=get(ProfilePop_id,'Value');
		set(ICA_id,'UserData',data_struct);

	case 'profile'
		plot_profile;

	case 'save'
		data_struct=get(gcbf,'UserData');
		eigengene_nr=get(ProfilePop_id,'Value');
		[fname,path]=uiputfile({'*.acl';'*.*'},'Zapisz do pliku');
		if fname~=0
			if isempty(strfind(fname,'.acl'))
				fname=[fname '.acl'];
			end;
			anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
			values=data_struct.v(:,eigengene_nr);
			
			records=cell(length(anames),1);
			for i=1:length(records)
				line=cell(1,2);
				line{1}=anames{i};
				line{2}=num2str(values(i));
				records{i}=line;
			end;
			save_cell(records,[path fname]);
		end

	case 'update_gui'
		data_struct=get(ICA_id,'UserData');

		if ~isempty(data_struct.v)
			components_count=size(data_struct.v,2);

			eigengene_string=cell(1,components_count);
			for i=1:components_count
				eigengene_string{i}=['IC' num2str(i)];
			end;
			set(ProfilePop_id,'Value',1,'String',eigengene_string,'Enable','on');
			set(ProfilePopText_id,'Enable','on');
			set(ProfileButt_id,'Enable','on');
			set(SaveButt_id,'Enable','on');
		end;


	case 'compute'
		set(Array_id,'Pointer','watch');
		set(ICA_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');

		if get(ArrayCenterCheck_id,'Value')==1
			data=data_center(data')';
		end;
		if get(GeneCenterCheck_id,'Value')==1
			data=data_center(data);
		end;
		if get(GeneStdCheck_id,'Value')==1
			data=data_normalize(data);
		end;
		eigenvectors_count=str2num(get(PCEdit_id,'String'));
		if eigenvectors_count>0
			[data,u,s,v]=data_denoise(data,eigenvectors_count);
		end;

		if get(ICAStabilizationCheck_id,'Value')==1
			ica_stabilization='on';
		else
			ica_stabilization='off';
		end;

		if get(ICARandGenCheck_id,'Value')==1
			rand('state',123);
			randn('state',123);
		end;

		retry=1;
		while retry==1
			[data_struct.v,data_struct.a,data_struct.w]=fastica(data,'stabilization',ica_stabilization);
			data_struct.v=data_struct.v';
			retry=0;
			if size(data_struct.v,2)<eigenvectors_count
				msg_str=sprintf('Nie byo moliwe wyznaczenie wszystkich skadowych.\nPonowi prb?');
				if strcmp(questdlg(msg_str,'MStat','Tak','Nie','Tak'),'Tak')==1
					retry=1;
				end;
			end;
		end;

		data_struct.component_nr=1;
		set(ICA_id,'UserData',data_struct);

		set(Array_id,'Pointer','arrow');
		set(ICA_id,'Pointer','arrow');

		ica_cb('update_gui');
end;
