function missing;

size_x=257;
size_y=365;

Missing_id=findobj('Tag','Missing');
if isempty(Missing_id)==0
	figure(Missing_id);
else
	Array_id=findobj(0,'Tag','ArrayView');
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

	missing_info=get(findobj(Array_id,'Tag','ValueEdit'),'UserData');
	vectors_count=str2num(get(findobj(Array_id,'Tag','ArrayNrEdit'),'String'));
	features_count=str2num(get(findobj(Array_id,'Tag','GeneNrEdit'),'String'));

	method_string={'SVD';'KNN';'rednia wiersza';'Mediana wiersza';'Minimum wiersza';'rednia klasy';'Mediana klasy';'Minimum klasy';'Min. danych';'Niezerowe min. danych';'Min. kolumny';'Niezerowe min. kolumny';'Zastpienie'};

	Missing_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','Brakujce wartoci', ...
		'KeyPressFcn',@figure_kb_cb,...
		'Tag','Missing');

	%%%%%%%%
	hnd=uipanel('Parent',Missing_id, ...
		'Title','Informacje:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 270 250 95], ...
		'Tag','MissingInfoFrame');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'Position',[10 10 230 20], ...
		'String','Procent wartoci wykrytych w prbkach', ...
		'Tag','RestoreButt', ...
		'CallBack','missing_cb(''column_percent'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 35 180 18], ...
		'HorizontalAlignment','left', ...
		'String','Liczba kompletnych wierszy:', ...
		'Style','text', ...
		'Tag','RowsEditText');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[195 35 45 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(missing_info(2)),...
		'Style','edit', ...
		'Tag','RowsEdit');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 60 180 18], ...
		'HorizontalAlignment','left', ...
		'String','Procent brakujcych wartoci:', ...
		'Style','text', ...
		'Tag','PercentEditText');

	h=uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[195 60 45 20], ...
		'HorizontalAlignment','right', ...
		'String',sprintf('%0.2f',100*missing_info(1)),...
		'Style','edit', ...
		'Tag','PercentEdit');
	
	%%%%%%%%
	hnd=uipanel('Parent',Missing_id, ...
		'Title','Filtracja:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 105 250 165], ...
		'Tag','FilterFrame');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 130 180 18], ...
		'String','Filtracja prbek',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','FilterArraysCheck',...
		'Callback','missing_cb(''check'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[10 105 170 18], ...
		'String',{'Max. liczba brakujcych','Max. procent brakujcych'}, ...
		'Style','popupmenu',...
		'Value',2, ...
		'Enable','off',...
		'Tag','FilterArraysPop', ...
		'Callback','missing_cb(''pop'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[195 105 45 20], ...
		'HorizontalAlignment','right', ...
		'String','40',...
		'UserData',[0 100 40 0],...
		'Style','edit', ...
		'Enable','off',...
		'Tag','FilterArraysEdit',...
		'Callback','missing_cb(''edit'')');


	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 80 180 18], ...
		'String','Filtracja cech',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','FilterCheck',...
		'Callback','missing_cb(''check'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[10 55 170 18], ...
		'String',{'Max. liczba brakujcych','Max. procent brakujcych','Pary cech'}, ...
		'Style','popupmenu',...
		'Value',1, ...
		'Enable','off',...
		'Tag','FilterPop', ...
		'Callback','missing_cb(''pop'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[195 55 45 20], ...
		'HorizontalAlignment','right', ...
		'String',round(0.2*vectors_count),...
		'UserData',[0 vectors_count round(0.2*vectors_count) 0],...
		'Style','edit', ...
		'Enable','off',...
		'Tag','FilterEdit',...
		'Callback','missing_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 30 170 18], ...
		'String','p-value testu rwnomiernoci:',...
		'Style','checkbox', ...
		'Value',0,...
		'Enable','off',...
		'Tag','ChiSquareCheck',...
		'Callback','missing_cb(''check'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[195 30 45 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(0.001),...
		'UserData',[0 1 0.001 0],...
		'Style','edit', ...
		'Enable','off',...
		'Tag','ChiSquareEdit',...
		'Callback','missing_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 5 220 18], ...
		'String','Zastpienie minimaln wartoci',...
		'Style','checkbox',...
		'Value',0,...
		'Enable','off',...
		'Tag','ChiSquareRestoreCheck',...
		'Callback','missing_cb(''check'')');

	%%%%%%%%
	hnd=uipanel('Parent',Missing_id, ...
		'Title','Imputacja:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 250 70], ...
		'Tag','RestoreFrame');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 30 90 18], ...
		'HorizontalAlignment','left', ...
		'Style','checkbox', ...
		'Value',0,...
		'String','Metoda: ', ...
		'Tag','RestoreCheck',...
		'Callback','missing_cb(''check'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[100 30 140 20], ...
		'String',method_string, ...
		'Style','popupmenu',...
		'Value',2, ...
		'Enable','off',...
		'Tag','RestoreMethodPop', ...
		'Callback','missing_cb(''pop'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 5 160 18], ...
		'HorizontalAlignment','left', ...
		'String','Rozmiar otoczenia:', ...
		'Style','text', ...
		'Enable','off',...
		'Tag','RestoreMethodEditText');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[195 5 45 20], ...
		'HorizontalAlignment','right', ...
		'String','4',...
		'UserData',[0 100 20 0],...
		'Enable','off',...
		'Style','edit', ...
		'Tag','RestoreMethodEdit',...
		'Callback','missing_cb(''edit'')');

	%%%%%%%
	uicontrol('Parent',Missing_id, ...
		'Units','pixels', ...
		'Position',[85 5 80 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
		'Callback','missing_cb(''close'')');

	uicontrol('Parent',Missing_id, ...
		'Units','pixels', ...
		'Position',[170 5 80 25], ...
		'String','Wykonaj', ...
		'Tag','RestoreButt', ...
		'CallBack','missing_cb(''restore'')');

end;