function missing_cb(action);

Array_id=findobj(0,'Tag','ArrayView');
Missing_id=findobj(0,'Tag','Missing');

config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

FilterArraysCheck_id=findobj(Missing_id,'Tag','FilterArraysCheck');
FilterArraysEdit_id=findobj(Missing_id,'Tag','FilterArraysEdit');
FilterArraysPop_id=findobj(Missing_id,'Tag','FilterArraysPop');

FilterCheck_id=findobj(get(Missing_id,'Child'),'Tag','FilterCheck');
FilterEdit_id=findobj(get(Missing_id,'Child'),'Tag','FilterEdit');
FilterPop_id=findobj(Missing_id,'Tag','FilterPop');

ChiSquareCheck_id=findobj(Missing_id,'Tag','ChiSquareCheck');
ChiSquareEdit_id=findobj(Missing_id,'Tag','ChiSquareEdit');
ChiSquareRestoreCheck_id=findobj(Missing_id,'Tag','ChiSquareRestoreCheck');

RestoreCheck_id=findobj(Missing_id,'Tag','RestoreCheck');
RestoreMethodPop_id=findobj(Missing_id,'Tag','RestoreMethodPop');
RestoreMethodEdit_id=findobj(Missing_id,'Tag','RestoreMethodEdit');
RestoreMethodEditText_id=findobj(Missing_id,'Tag','RestoreMethodEditText');

restore_method_string={'svd';'knn';'row_mean';'row_median';'row_min';'class_mean';'class_median';'class_min';'data_min';'nonzero_data_min';'column_min';'nonzero_column_min';'replace'};

switch action
	case 'close'
		delete(Missing_id);
		%delete(findobj(0,'Tag','MissingTable'));

	case 'edit'
		Edit_id=gcbo;
		num=str2num(get(Edit_id,'String'));
		limits=get(Edit_id,'UserData');

		if isempty(num)==1
			num=limits(3);
			beep;
		else
			switch limits(4)
				case 0
					if num<limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
				case 1
					if num<=limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 2
					if num<limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 3
					if num<=limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
			end;
		end;
		set(Edit_id,'String',num2str(num));

	case 'check'
		if get(gcbo,'Value')==1
			state='on';
		else
			state='off';
		end;
		switch gcbo
			case RestoreCheck_id
						set(RestoreMethodPop_id,'Enable',state);
						set(RestoreMethodEdit_id,'Enable',state);
						set(RestoreMethodEditText_id,'Enable',state);
			case FilterArraysCheck_id
						set(FilterArraysEdit_id,'Enable',state);
						set(FilterArraysPop_id,'Enable',state);

			case FilterCheck_id
						set(FilterEdit_id,'Enable',state);
						set(FilterPop_id,'Enable',state);
						set(ChiSquareCheck_id,'Enable',state);
						if strcmp(state,'on')==1 & get(ChiSquareCheck_id,'Value')==1
							set(ChiSquareEdit_id,'Enable','on');
							set(ChiSquareRestoreCheck_id,'Enable','on');
						else
							set(ChiSquareEdit_id,'Enable','off');
							set(ChiSquareRestoreCheck_id,'Enable','off');
						end;
			case ChiSquareCheck_id
						set(ChiSquareEdit_id,'Enable',state);
						set(ChiSquareRestoreCheck_id,'Enable',state);
		end;

	case 'pop'
		switch gcbo
			case FilterArraysPop_id
				features_count=str2num(get(findobj(Array_id,'Tag','GeneNrEdit'),'String'));
				switch get(FilterArraysPop_id,'Value')
					case 1
						limits=[0 features_count round(0.4*features_count) 0];
					case 2
						limits=[0 100 40 0];
				end;
				set(FilterArraysEdit_id,'UserData',limits);
				set(FilterArraysEdit_id,'String',num2str(limits(3)));

			case FilterPop_id
				vectors_count=str2num(get(findobj(Array_id,'Tag','ArrayNrEdit'),'String'));
				switch get(FilterPop_id,'Value')
					case 1
						limits=[0 vectors_count round(0.2*vectors_count) 0];
						set(FilterEdit_id,'Enable','on');
						set(ChiSquareCheck_id,'Enable','on','Value',0);
					case 2
						limits=[0 100 20 0];
						set(FilterEdit_id,'Enable','on');
						set(ChiSquareCheck_id,'Enable','on','Value',0);
					case 3
						limits=[0 100 20 0];
						set(FilterEdit_id,'Enable','off');
						set(ChiSquareCheck_id,'Enable','off','Value',0);
				end;
				set(FilterEdit_id,'UserData',limits);
				set(FilterEdit_id,'String',num2str(limits(3)));
				set(ChiSquareEdit_id,'Enable','off');
				set(ChiSquareRestoreCheck_id,'Enable','off');

			case RestoreMethodPop_id
				switch get(RestoreMethodPop_id,'Value')
					case 1
						set(RestoreMethodEdit_id,'Enable','on');
						set(RestoreMethodEdit_id,'String',num2str(20));
						set(RestoreMethodEdit_id,'UserData',[0 100 20 0]);
						set(RestoreMethodEditText_id,'Enable','on');
						set(RestoreMethodEditText_id,'String','Procent cech wasnych:');
					case 2
						set(RestoreMethodEdit_id,'Enable','on');
						set(RestoreMethodEdit_id,'String',num2str(4));
						set(RestoreMethodEdit_id,'UserData',[1 200 4 0]);
						set(RestoreMethodEditText_id,'Enable','on');
						set(RestoreMethodEditText_id,'String','Rozmiar otoczenia:');
					case 13
						set(RestoreMethodEdit_id,'Enable','on');
						set(RestoreMethodEdit_id,'String',num2str(0));
						set(RestoreMethodEdit_id,'UserData',[-inf inf 0 0]);
						set(RestoreMethodEditText_id,'Enable','on');
						set(RestoreMethodEditText_id,'String','Warto zastpujca:');
					otherwise
						set(RestoreMethodEdit_id,'Enable','off');
						set(RestoreMethodEditText_id,'Enable','off');
				end;
		end;

	case 'column_percent'
%		missing_stat;
		missing_table('create');
		delete(Missing_id);
		
	case 'restore'
		set(Array_id,'Pointer','watch');
		set(Missing_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');
		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
		gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
		aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
		anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
		acnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');
		gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
		stat_struct=get(findobj(Array_id,'Tag','Select1D'),'UserData');
		glist=get(findobj(Array_id,'Tag','DatasetPanel'),'UserData');
		class_nr=max(aorder);

		if get(FilterArraysCheck_id,'Value')==1
			max_missing=str2num(get(FilterArraysEdit_id,'String'));
			if get(FilterArraysPop_id,'Value')==2
				max_missing=round(max_missing*size(data,1)/100);
			end;

			list=find(sum(isnan(data),1)>max_missing);

			data(:,list)=[];
			anames(list)=[];
			aorder(list)=[];
		end;

		if get(FilterCheck_id,'Value')==1
			max_missing=str2num(get(FilterEdit_id,'String'));
			if get(FilterPop_id,'Value')==2
				max_missing=round(max_missing*size(data,2)/100);
			end;

			if get(FilterPop_id,'Value')==3
				order=name2order(gnames,' (');
				groups=sort(unique(order));
				for i=1:length(groups)
					index=find(order==groups(i));
					if ~isempty(index) & length(index)>1
						nan_count=sum(isnan(data(index,:)),2);
						index=index(find(nan_count>min(nan_count)));
						data(index,:)=-Inf;
					end;
				end;
				list=find(sum(isinf(data),2)==size(data,2));
				data(list,:)=[];
			else
				if get(ChiSquareCheck_id,'Value')==1
					[data,list]=missing_filter(data,max_missing,aorder,str2num(get(ChiSquareEdit_id,'String')),get(ChiSquareRestoreCheck_id,'Value'));
				else
					[data,list]=missing_filter(data,max_missing);
				end;
			end;

			gnames(list)=[];
			gorder(list)=[];
			glist(list)=[];
			stat_struct.fc(list)=[];
			stat_struct.pval(list)=[];
			stat_struct.fdr(list)=[];
			stat_struct.n(list)=[];			
		end;

		if get(RestoreCheck_id,'Value')==1
			method=restore_method_string{get(RestoreMethodPop_id,'Value')};
			switch method
				case 'knn'
					param=max(str2num(get(RestoreMethodEdit_id,'String')),size(data,2));

				case 'svd'
					param=str2num(get(RestoreMethodEdit_id,'String'))/100;

				case 'replace'
					param=str2num(get(RestoreMethodEdit_id,'String'));

				case {'class_mean','class_median','class_min'}
					param=aorder;

				otherwise
					param=0;
			end;

			if strcmp(method,'knn')==1
				data=missing_knn(data);
				list=[];
			else
				[data,list]=missing_restore(data,method,param);
			end;

			gnames(list)=[];
			gorder(list)=[];
			glist(list)=[];
			stat_struct.fc(list)=[];
			stat_struct.pval(list)=[];
			stat_struct.fdr(list)=[];
			stat_struct.n(list)=[];
		end;

		if isempty(data)
			beep;
			warndlg('Usunite wszystkie prbki lub cechy','MStat');
			set(Array_id,'Pointer','arrow');
			set(Missing_id,'Pointer','arrow');
			return;
		else
			switch questdlg(sprintf('Liczba prbek po filtacji: %d\nLiczba cech po filtacji: %d',size(data,2),size(data,1)),'MStat','Akceptuj','Anuluj','Akceptuj')
				case 'Anuluj'
					set(Array_id,'Pointer','arrow');
					set(Missing_id,'Pointer','arrow');
					return;
				case 'Akceptuj'
					%uprzadkowanie nazw klas i podziau probek
					clist=1:length(acnames);
					acnames=acnames(clist(unique(aorder)));
					aorder=reorder_labels(aorder);

					%uprzadkowanie nazw grup i podziau genow
					clist=1:length(gcnames);
					gcnames=gcnames(clist(unique(gorder)));
					gorder=reorder_labels(gorder);

					set(Array_id,'UserData',data);
					set(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData',gnames);
					set(findobj(Array_id,'Tag','GeneClassAxes'),'UserData',gorder);
					set(findobj(Array_id,'Tag','DatasetPanel'),'UserData',glist);
					set(findobj(Array_id,'Tag','GeneClassPop'),'Value',1,'UserData',gcnames);
					set(findobj(Array_id,'Tag','Select1D'),'UserData',stat_struct);

					set(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData',anames);
					set(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData',aorder);
					set(findobj(Array_id,'Tag','ArrayClassPop'),'Value',1,'UserData',acnames);

					mstat_cb('reset_selection');
					mstat_cb('update_missing');
					mstat_cb('do_gui');
					mstat_cb('do_menu');
					mstat_cb('prepare_data');
					mstat_cb('prepare_axis');
					mstat_cb('redraw');
					
					%aktualizacja tabel
					GeneTable_id=findobj('Tag','GeneTable');
					if ~isempty(GeneTable_id)
						genes_table('create')
					end;
					ValueTable_id=findobj('Tag','ValueTable');
					if ~isempty(ValueTable_id)
						values_table('create')
					end;
					GroupTable_id=findobj('Tag','GroupTable');
					if ~isempty(GroupTable_id)
						groups_table('create')
					end;
					
					set(Array_id,'Pointer','arrow');
					set(Missing_id,'Pointer','arrow');

					delete(Missing_id);
					%delete(findobj(0,'Tag','MissingTable'));
			end;
		end;
end;