function normalize_arrays_cb(action);

Array_id=findobj(0,'Tag','ArrayView');
ANorm_id=findobj(0,'Tag','ANorm');

ListRadio_id=findobj(ANorm_id,'Tag','ListRangeRadio');
ListButt_id=findobj(ANorm_id,'Tag','ListRangeButt');
SingleRadio_id=findobj(ANorm_id,'Tag','SingleRangeRadio');
SingleEdit_id=findobj(ANorm_id,'Tag','SingleRangeEdit');
GroupRadio_id=findobj(ANorm_id,'Tag','GroupRangeRadio');
GroupEdit_id=findobj(ANorm_id,'Tag','GroupRangeEdit');

DivRadio_id=findobj(ANorm_id,'Tag','DivRadio');
DivPop_id=findobj(ANorm_id,'Tag','DivPop');
DivNormCheck_id=findobj(ANorm_id,'Tag','DivNormCheck');
DivViewButt_id=findobj(ANorm_id,'Tag','DivViewButt');
RegressRadio_id=findobj(ANorm_id,'Tag','RegressRadio');
RegressPop_id=findobj(ANorm_id,'Tag','RegressPop');
SmoothRadio_id=findobj(ANorm_id,'Tag','SmoothRadio');
SmoothPop_id=findobj(ANorm_id,'Tag','SmoothPop');
QuantileRadio_id=findobj(ANorm_id,'Tag','QuantileRadio');
IrsRadio_id=findobj(ANorm_id,'Tag','IrsRadio');

LogCheck_id=findobj(ANorm_id,'Tag','LogCheck');
LogPop_id=findobj(ANorm_id,'Tag','LogPop');

RadioHnd_id=findobj(ANorm_id,'Style','radio');

div_string={'dmean','tmean','dgmean','dmedian','dsum'};
regress_string={'lreg_a','lreg_ab','lreg_ls'};
smooth_string={'lowess','rlowess','loess','rloess','cyclic_loess','rcyclic_loess','invset_loess','rinvset_loess'};

config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

switch action
	case 'log_check'
		if get(gcbo,'Value')==1		
			set(LogPop_id,'Enable','on');
		else
			set(LogPop_id,'Enable','off');
		end;

	case 'radio'
		CurrentRadio_id=gcbo;
		for i=1:length(RadioHnd_id)
			if ~isempty(strfind(get(RadioHnd_id(i),'Tag'),'Range'))
				if RadioHnd_id(i)~=CurrentRadio_id
					set(RadioHnd_id(i),'Value',0);
				else
					set(RadioHnd_id(i),'Value',1);
				end
			end;
		end;
		if strcmp(get(CurrentRadio_id,'Tag'),'ListRangeRadio')
			set(ListButt_id,'Enable','on');
		else
			set(ListButt_id,'Enable','off');
		end;
		if strcmp(get(CurrentRadio_id,'Tag'),'GroupRangeRadio')
			set(GroupEdit_id,'Enable','on');
		else
			set(GroupEdit_id,'Enable','off');
		end;
		if strcmp(get(CurrentRadio_id,'Tag'),'SingleRangeRadio')
			set(SingleEdit_id,'Enable','on');
		else
			set(SingleEdit_id,'Enable','off');
		end;

	case 'radio2'
		CurrentRadio_id=gcbo;
		for i=1:length(RadioHnd_id)
			if isempty(strfind(get(RadioHnd_id(i),'Tag'),'Range'))
				if RadioHnd_id(i)~=CurrentRadio_id
					set(RadioHnd_id(i),'Value',0);
				else
					set(RadioHnd_id(i),'Value',1);
				end;
			end;
		end;
		if CurrentRadio_id==DivRadio_id
			set(DivPop_id,'Enable','on');            
			set(DivNormCheck_id,'Enable','on');
			set(DivViewButt_id,'Enable','on');            			
            set(RegressPop_id,'Enable','off');
			set(SmoothPop_id,'Enable','off');
			return;
		end;
		if CurrentRadio_id==RegressRadio_id
			set(DivPop_id,'Enable','off');
			set(DivNormCheck_id,'Enable','off');
			set(DivViewButt_id,'Enable','off');            			
			set(RegressPop_id,'Enable','on');
			set(SmoothPop_id,'Enable','off');
			return;
		end;
		if CurrentRadio_id==SmoothRadio_id
			set(DivPop_id,'Enable','off');
			set(DivNormCheck_id,'Enable','off');
			set(DivViewButt_id,'Enable','off');            			
			set(RegressPop_id,'Enable','off');
			set(SmoothPop_id,'Enable','on');
			return;
		end;
		set(DivPop_id,'Enable','off');
		set(DivNormCheck_id,'Enable','off');
        set(DivViewButt_id,'Enable','off');
		set(RegressPop_id,'Enable','off');
		set(SmoothPop_id,'Enable','off');

	case 'load_list'
		[fname,path,format]=uigetfile({'*.gnm','Nazwy cech (*.gnm)'; '*.*','Wszystkie pliki'},'Otwrz plik',config.open_path);
		file=[path,fname];
		if file~=0
			user_list=load_cell(file);
			if ~isempty(user_list) && min(size(user_list))==1
				set(ANorm_id,'UserData',user_list);
			end;
		end;

	case 'view_coeffs'
		set(Array_id,'Pointer','watch');
		set(ANorm_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');
		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
		gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
		gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');

		if get(LogCheck_id,'Value')==1
			method_str=get(LogPop_id,'String');
			switch char(method_str(get(LogPop_id,'Value')))
				case 'log_2'
					data=log2(data);
				case 'log_10'
					data=log10(data);
				case 'log_e'
					data=log_e(data);
				case 'exp_2'
					data=2.^(data);
				case 'exp_10'
					data=10.^(data);
				case 'exp_e'
					data=exp(1).^(data);
			end;
		end;

		if get(ListRadio_id,'Value')==1 || get(SingleRadio_id,'Value')==1 || get(GroupRadio_id,'Value')==1
			user_list={};
			if get(SingleRadio_id,'Value')==1
				gene_name=get(SingleEdit_id,'String');
				if ~isempty(gene_name)
					user_list{1}=gene_name;
				else
					beep;
					set(Array_id,'Pointer','arrow');
					set(ANorm_id,'Pointer','arrow');
					warndlg('Nazwa cechy nie zostaa zdefiniowana','MStat');
					return;
				end;
			else
				if get(GroupRadio_id,'Value')==1
					group_name=get(GroupEdit_id,'String');
					if ~isempty(group_name)
						for i=1:length(gcnames)
							if strcmp(gcnames{i},group_name)
								index=find(gorder==i);
								if ~isempty(index)
									user_list=cell(length(index),1);
									for j=1:length(index)
										user_list{j}=char(gnames{index(j)});
									end;
								end;
								break;
							end;
						end;
					else
						beep;
						set(Array_id,'Pointer','arrow');
						set(ANorm_id,'Pointer','arrow');
						warndlg('Nazwa grupy nie zostaa zdefiniowana','MStat');
						return;
					end;
				else
					user_list=get(ANorm_id,'UserData');
				end;
			end;

			if ~isempty(user_list)
				list=name2index(user_list,gnames);
				if isempty(list)
					beep;
					set(ANorm_id,'Pointer','arrow');
					warndlg('Nie znaleziono cech z listy','MStat');
					return;
				end;
			else
				beep;
				set(Array_id,'Pointer','arrow');
				set(ANorm_id,'Pointer','arrow');
				warndlg('Lista cech nie zostaa wczytany','MStat');
				return;
			end;
		else
			list=1:size(data,1);
		end;

		if get(DivRadio_id,'Value')==1
			method=div_string{get(DivPop_id,'Value')};
		end;

		coeffs=data_arraynorm(data,list,method,get(DivNormCheck_id,'Value'))
		set(Array_id,'Pointer','arrow');
		set(ANorm_id,'Pointer','arrow');
		plot_coeffs(coeffs);
		
	case 'normalize'
		set(Array_id,'Pointer','watch');
		set(ANorm_id,'Pointer','watch');
		pause(0.01);
		
		data=get(Array_id,'UserData');

		if get(LogCheck_id,'Value')==1
			method_str=get(LogPop_id,'String');
			switch char(method_str(get(LogPop_id,'Value')))
				case 'log_2'
					data=log2(data);
				case 'log_10'
					data=log10(data);
				case 'log_e'
					data=log_e(data);
				case 'exp_2'
					data=2.^(data);
				case 'exp_10'
					data=10.^(data);
				case 'exp_e'
					data=exp(1).^(data);
			end;
		end;

		if get(ListRadio_id,'Value')==1 || get(SingleRadio_id,'Value')==1 || get(GroupRadio_id,'Value')==1
            gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
            gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
            gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
        
			user_list={};
			if get(SingleRadio_id,'Value')==1
				gene_name=get(SingleEdit_id,'String');
				if ~isempty(gene_name)
					user_list{1}=gene_name;
				else
					beep;
					set(Array_id,'Pointer','arrow');
					set(ANorm_id,'Pointer','arrow');
					warndlg('Nazwa cechy nie zostaa zdefiniowana','MStat');
					return;
				end;
			else
				if get(GroupRadio_id,'Value')==1
					group_name=get(GroupEdit_id,'String');
					if ~isempty(group_name)
						for i=1:length(gcnames)
							if strcmp(gcnames{i},group_name)
								index=find(gorder==i);
								if ~isempty(index)
									user_list=cell(length(index),1);
									for j=1:length(index)
										user_list{j}=char(gnames{index(j)});
									end;
								end;
								break;
							end;
						end;
					else
						beep;
						set(Array_id,'Pointer','arrow');
						set(ANorm_id,'Pointer','arrow');
						warndlg('Nazwa grupy nie zostaa zdefiniowana','MStat');
						return;
					end;
				else
					user_list=get(ANorm_id,'UserData');
				end;
			end;

			if ~isempty(user_list)
				list=name2index(user_list,gnames);
				if isempty(list)
					beep;
					set(Array_id,'Pointer','arrow');
					set(ANorm_id,'Pointer','arrow');
					warndlg('Nie znaleziono cech z listy','MStat');
					return;
				end;
			else
				beep;
				set(Array_id,'Pointer','arrow');
				set(ANorm_id,'Pointer','arrow');
				warndlg('Lista cech nie zostaa wczytany','MStat');
				return;
			end;
		else
			list=1:size(data,1);
		end;
		
		if get(DivRadio_id,'Value')==1
			method=div_string{get(DivPop_id,'Value')};
			[coeffs,data]=data_arraynorm(data,list,method,get(DivNormCheck_id,'Value'));
        elseif get(RegressRadio_id,'Value')==1
			method=regress_string{get(RegressPop_id,'Value')};
			[coeffs,data]=data_arraynorm(data,list,method,get(DivNormCheck_id,'Value'));
        elseif get(SmoothRadio_id,'Value')==1
			method=smooth_string{get(SmoothPop_id,'Value')};
			data=data_arraynorm_nl(data,method,0.5);
        elseif get(QuantileRadio_id,'Value')==1
			data=data_arraynorm_nl(data,'quantile',0);
        elseif get(IrsRadio_id,'Value')==1
            aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');            
            anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
            
			data=data_arraynorm_irs(data,aorder,anames);            
		end;

		if get(LogCheck_id,'Value')==1
			method_str=get(LogPop_id,'String');
			switch char(method_str(get(LogPop_id,'Value')))
				case 'log_2'
					data=2.^(data);
				case 'log_10'
					data=10.^(data);
				case 'log_e'
					data=exp(1).^(data);
				case 'exp_2'
					data=log2(data);
				case 'exp_10'
					data=log10(data);
				case 'exp_e'
					data=log_e(data);
			end;
		end;

		set(Array_id,'UserData',data);

		mstat_cb('reset_selection');
		mstat_cb('do_gui');
		mstat_cb('prepare_data');
		mstat_cb('prepare_axis');
		mstat_cb('redraw');
		set(Array_id,'Pointer','arrow');
		set(ANorm_id,'Pointer','arrow');
		delete(ANorm_id);
end;
return;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function plot_coeffs(coeffs)

PlotCoeffs_id=figure('Units','pixels',...
			'Visible','on',...
			'Color',get(0,'defaultUicontrolBackgroundColor'),...
			'NumberTitle','off',...
			'MenuBar','none',...
			'Resize','off',...
			'Name','Wspczynniki normalizacji',...
			'KeyPressFcn',@figure_kb_cb,...							
			'Tag','PlotCoeffs');

FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','figsave_cb');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

hnd=plot(ones(1,size(coeffs,2)).*coeffs(1,:)-coeffs(2,:));
set(hnd,'Color',[0 0 1],'Marker','o','MarkerSize',2,'MarkerFaceColor',[0 0 1]);

set(gca,'XLim',[1 length(coeffs)],'XTick',[1:2:length(coeffs)],'FontSize',8,'box','on');
xlabel('Numer prbki');
ylabel('Warto');
return;