function sel1D_corr_cb(action);

Array_id=findobj(0,'Tag','ArrayView');
Sel1DCorr_id=findobj(0,'Tag','Selection1D_corr');

MethodPop_id=findobj(Sel1DCorr_id,'Tag','MethodPop');
MTestCheck_id=findobj(Sel1DCorr_id,'Tag','MTestCheck');
MTestPop_id=findobj(Sel1DCorr_id,'Tag','MTestPop');
ThresholdCheck_id=findobj(Sel1DCorr_id,'Tag','ThresholdCheck');
ThresholdEdit_id=findobj(Sel1DCorr_id,'Tag','ThresholdEdit');
ThresholdEditText_id=findobj(Sel1DCorr_id,'Tag','ThresholdEditText');
FCCheck_id=findobj(Sel1DCorr_id,'Tag','FCCheck');
FCPop_id=findobj(Sel1DCorr_id,'Tag','FCPop');
FeaturesNrCheck_id=findobj(Sel1DCorr_id,'Tag','FeaturesNrCheck');
FeaturesNrEdit_id=findobj(Sel1DCorr_id,'Tag','FeaturesNrEdit');
FeaturesNrEdit_id=findobj(Sel1DCorr_id,'Tag','FeaturesNrEdit');
OrderButt_id=findobj(Sel1DCorr_id,'Tag','OrderButt');
OrderCheck_id=findobj(Sel1DCorr_id,'Tag','OrderCheck');
LogPop_id=findobj(Sel1DCorr_id,'Tag','LogPop');

method_string={'corrp';'corrs';};
mtest_string={'fdr_bh','fdr_bh_tst','fdr_bj','fdr_storey','sidak','bonferroni','holm','max_pval','min_corr'};
sort_string={'positive';'negative';'all'};


config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

switch action
	case 'edit'
		Edit_id=gcbo;
		num=str2num(get(Edit_id,'String'));
		limits=get(Edit_id,'UserData');

		if isempty(num)==1
			num=limits(3);
			beep;
		else
			switch limits(4)
				case 0
					if num<limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
				case 1
					if num<=limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 2
					if num<limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 3
					if num<=limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
			end;
		end;
		set(Edit_id,'String',num2str(num));

	case 'check'
		switch gcbo
			case FCCheck_id
				if get(FCCheck_id,'Value')==1
					set(FCPop_id,'Enable','on');
				else
					set(FCPop_id,'Enable','off');
				end;

			case MTestCheck_id
				if get(MTestCheck_id,'Value')==1
					set(MTestPop_id,'Enable','on');
					set(ThresholdEdit_id,'Enable','on');
					set(ThresholdEditText_id,'Enable','on');
				else
					set(MTestPop_id,'Enable','off');
					set(ThresholdEdit_id,'Enable','off');
					set(ThresholdEditText_id,'Enable','off');
				end;

			case FeaturesNrCheck_id
				if get(FeaturesNrCheck_id,'Value')==1
					set(FeaturesNrEdit_id,'Enable','on');
				else
					set(FeaturesNrEdit_id,'Enable','off');
				end;
		end;

	case 'pop'
		if get(MTestCheck_id,'Value')==9
			set(ThresholdEditText_id,'String','Prg istotnoci:');
		else
			set(ThresholdEditText_id,'String','Prg korelacji:');
		end;

	case 'load_order'
		[fname,path]=uigetfile({'*.acl';'*.*'},'Otwrz plik',config.open_path);
		if fname~=0
			data=get(Array_id,'UserData');
			vectors_count=size(data,2);

			records=load_cell2([path fname]);
			records_count=length(records);

			if records_count>=vectors_count
				names=cell(records_count,1);
				order=zeros(records_count,1);
				for i=1:records_count
					record=records{i};
					names{i}=record{1};
					order(i)=str2num(record{2});
				end;

				anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
				index=name2index(anames,names);
				values=order(index);

				if length(values)==vectors_count
					set(Sel1DCorr_id,'UserData',values);
				else
					beep;
					if strcmp(method,'anova2')
						warndlg('Nie znaleziono wartoci dla wszystkich prbek','MStat');
					end;
				end;
			else
				beep;
				warndlg('Liczba wartoci mniejsza od liczby prbek','MStat');
				return;
			end;
		end;

	case 'selection'
		set(Array_id,'Pointer','watch');
		set(Sel1DCorr_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');
		image_data=get(findobj(Array_id,'Tag','ArrayAxes'),'UserData');
		anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
		aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
		gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
		glist=get(findobj(Array_id,'Tag','DatasetPanel'),'UserData');
		gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
		stat_struct=get(findobj(Array_id,'Tag','Select1D'),'UserData');	
		
		selected=1:str2num(get(findobj(Array_id,'Tag','GeneNrEdit'),'String'));

		method=method_string{get(MethodPop_id,'Value')};
		adjust_method='none';
		sort_method='none';
		threshold=str2num(get(ThresholdEdit_id,'String'));

		FCPop_id=findobj(Sel1DCorr_id,'Tag','FCPop');

		fc=[];
		p=[];
		f=[];

		values=get(Sel1DCorr_id,'UserData');
		if isempty(values)
			beep;
			warndlg('Zmienna nie zostaa wczytana','MStat');
			set(Sel1DCorr_id,'Pointer','arrow');
			set(Array_id,'Pointer','arrow');
			return;
		else
			zero_ind=find(values==0);
			log_str=get(LogPop_id,'String');
			switch char(log_str(get(LogPop_id,'Value')))
				case 'log_2'
					values(zero_ind)=1;
					values=log2(values);
					values(zero_ind)=0;
				case 'log_10'
					values(zero_ind)=1;
					values=log10(values);
					values(zero_ind)=0;
				case 'log_e'
					values(zero_ind)=1;
					values=log_e(values);
					values(zero_ind)=0;
				case 'exp_2'
					values=2.^(values);
				case 'exp_10'
					values=10.^(values);
				case 'exp_e'
					values=exp(1).^(values);
			end;
		end;
		if get(MTestCheck_id,'Value')==1
			adjust_method=mtest_string{get(MTestPop_id,'Value')};
		end;

		if get(FCCheck_id,'Value')==1
			sort_method=sort_string{get(FCPop_id,'Value')};
		end;
		
		[c,p,f,index]=selection1D_corr(data,values,method,adjust_method,threshold,sort_method);

		data=data(index,:);
		selected=selected(index);

		if get(FeaturesNrCheck_id,'Value')==1 & ~isempty(selected)
			index=1:min(str2num(get(FeaturesNrEdit_id,'String')),size(data,1));
			data=data(index,:);
			selected=selected(index);
			if ~isempty(p)
				f=f(index);
				p=p(index);
			end;
			if ~isempty(fc)
				fc=fc(index);
			end;
		end;

		if isempty(selected)
			beep;
			warndlg('Nie ma cech speniajcych warunki','MStat');
			set(Sel1DCorr_id,'Pointer','arrow');
			set(Array_id,'Pointer','arrow');
			return;
		else
			if ~isempty(p)
				msg_str=sprintf('Liczba cech speniajcych warunki: %d \n(min corr=%0.5g, max p-value=%0.5g, FDR=%0.5g)',length(selected),c(end),p(end),max(f));
			else
				msg_str=sprintf('Liczba cech speniajcych warunki: %d',length(selected));
			end;

			switch questdlg(msg_str,'MStat','OK','Cofnij','OK')
				case 'Cofnij'
					set(Sel1DCorr_id,'Pointer','arrow');
					set(Array_id,'Pointer','arrow');
					return;
				case 'OK'
					image_data=image_data(selected,:);
					gnames=gnames(selected);
					gorder=gorder(selected);
					glist=glist(selected);
					stat_struct.n=stat_struct.n(selected);

					%uprzadkowanie nazw grup i podziau genow
					clist=1:length(gcnames);
					gcnames=gcnames(clist(unique(gorder)));
					gorder=reorder_labels(gorder);

					%utworzenie stat_struct
					test_str=get(MethodPop_id,'String');
					stat_struct.test=test_str{get(MethodPop_id,'Value')};

					stat_struct.test='CORR';
					if ~isempty(p)
%						stat_struct.pval=p;
						stat_struct.pval=c;
						stat_struct.fdr=f;
					else
						stat_struct.pval=NaN*ones(size(data,1),1);
						stat_struct.fdr=NaN*ones(size(data,1),1);
					end;
					if ~isempty(fc)
						stat_struct.fc=fc;
					else
						stat_struct.fc=NaN*ones(size(data,1),1);
					end;

					if get(OrderCheck_id,'Value')==1
						[s,index]=sort(values);
						data=data(:,index);
						image_data=image_data(:,index);
						anames=anames(index);
						aorder=aorder(index);
					end;
					%zwrocenie wynikow
					set(Array_id,'UserData',data);
					set(findobj(Array_id,'Tag','ArrayAxes'),'UserData',image_data);
					set(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData',anames);
					set(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData',aorder);
					set(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData',gnames);
					set(findobj(Array_id,'Tag','GeneClassAxes'),'UserData',gorder);
					set(findobj(Array_id,'Tag','DatasetPanel'),'UserData',glist);
					set(findobj(Array_id,'Tag','GeneClassPop'),'Value',1,'UserData',gcnames);
					set(findobj(Array_id,'Tag','Select1D'),'UserData',stat_struct);

					mstat_cb('reset_selection');
					mstat_cb('do_gui');
					mstat_cb('prepare_axis');
					mstat_cb('redraw');

					%aktualizacja tabel
					GeneTable_id=findobj('Tag','GeneTable');
					if ~isempty(GeneTable_id)
						genes_table('create')
					end;
					ValueTable_id=findobj('Tag','ValueTable');
					if ~isempty(ValueTable_id)
						values_table('create')
					end;
					GroupTable_id=findobj('Tag','GroupTable');
					if ~isempty(GroupTable_id)
						groups_table('create')
					end;

					set(Sel1DCorr_id,'Pointer','arrow');
					set(Array_id,'Pointer','arrow');
					delete(Sel1DCorr_id);
			end;
		end;
end;
