function ica();

size_x=230;
size_y=270;

Sel1DICA_id=findobj('Tag','Selection1D_ica');
if isempty(Sel1DICA_id)==0
	figure(Sel1DICA_id);
else
	Array_id=findobj(0,'Tag','ArrayView');
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

	Sel1DICA_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','Selekcja ICA', ...
		'KeyPressFcn',@figure_kb_cb,...				
		'Tag','Selection1D_ica');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 170 220 95], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','ProcessingFrame');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 253 125 18], ...
		'HorizontalAlignment','left', ...
		'String',' Przetwarzanie wstpne: ', ...
		'Style','text', ...
		'Tag','ProcessingFrameText');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[160 235 60 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(4),...
		'Style','edit', ...
		'Tag','PCEdit');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 233 150 18], ...
		'HorizontalAlignment','left', ...
		'String','Liczba skadowych gwnych:',...
		'Style','text', ...
		'Tag','EnthropyEditText');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 215 130 18], ...
		'String','Centrowanie cech',...
		'Style','checkbox', ...
		'Value',1,...
		'Tag','GeneCenterCheck');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 195 130 18], ...
		'String','Centrowanie prbek',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','ArrayCenterCheck');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 175 130 18], ...
		'String','Standaryzacja cech',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','GeneStdCheck');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 105 220 55], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','ICAFrame');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 148 115 18], ...
		'HorizontalAlignment','left', ...
		'String',' Ustawienia algorytmu: ', ...
		'Style','text', ...
		'Tag','ICAFrameText');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 130 130 18], ...
		'String','Stabilizacja',...
		'Style','checkbox', ...
		'Value',1,...
		'Tag','ICAStabilizationCheck');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 110 200 18], ...
		'String','Ustalenie stanu generatora',...
		'Style','checkbox', ...
		'Value',1,...
		'Tag','ICARandGenCheck');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 220 60], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','Selection1DFrame');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 83 105 18], ...
		'HorizontalAlignment','left', ...
		'String',' Parametry selekcji: ', ...
		'Style','text', ...
		'Tag','Selection1DFrameText');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[160 65 60 20], ...
		'String',{'IC1'}, ...
		'enable','off',...
		'Style','popupmenu',...
		'Value',1, ...
		'Tag','ProfilePop', ...
		'Callback','');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 63 100 18], ...
		'HorizontalAlignment','left', ...
		'enable','off',...
		'String','Numer skadowej:',...
		'Style','text', ...
		'Tag','ProfilePopText');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[160 40 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'String',num2str(0.8),...
		'UserData',[0 1 0.8 0],...
		'enable','off',...
		'Tag','ThresholdEdit',...
		'Callback','sel1D_ica_cb(''edit'')');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 38 100 18], ...
		'HorizontalAlignment','left', ...
		'String',' Minimalny udzia:', ...
		'enable','off',...
		'Style','text', ...
		'Tag','ThresholdEditText');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'Position',[5 5 70 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
		'Callback','delete(gcbf);');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'Position',[80 5 70 25], ...
		'String','Wyznacz', ...
		'Tag','CancelButt', ...
		'Callback','sel1D_ica_cb(''compute'');');

	uicontrol('Parent',Sel1DICA_id, ...
		'Units','pixels', ...
		'Position',[155 5 70 25], ...
		'String','Seleckcja', ...
		'enable','off',...
		'Tag','Selection1DButt', ...
		'Callback','sel1D_ica_cb(''selection'');');
end;

