function sel1D_svd;

size_x=245;
size_y=180;

Sel1DSvd_id=findobj('Tag','Selection1D_svd');
if isempty(Sel1DSvd_id)==0
	figure(Sel1DSvd_id);
else
	Array_id=findobj(0,'Tag','ArrayView');
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

	data=get(Array_id,'UserData');

	eigengene_count=min(size(data,1),size(data,2));
	eigengene_string=cell(1,eigengene_count);
	for i=1:eigengene_count
		eigengene_string{i}=num2str(i);
	end;

	Sel1DSvd_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','Selekcja SVD', ...
		'KeyPressFcn',@figure_kb_cb,...				
		'Tag','Selection1D_svd');


	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 105 240 70], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','ProcessingFrame');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 163 130 18], ...
		'HorizontalAlignment','left', ...
		'String',' Przetwarzanie wstpne: ', ...
		'Style','text', ...
		'Tag','ProcessingFrameText');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 150 130 18], ...
		'String','Centrowanie cech',...
		'Style','checkbox', ...
		'Value',1,...
		'Tag','GeneCenterCheck');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 130 130 18], ...
		'String','Centrowanie prbek',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','ArrayCenterCheck');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 110 130 18], ...
		'String','Standaryzacja cech',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','GeneStdCheck');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 240 60], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','Selection1DFrame');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 83 105 18], ...
		'HorizontalAlignment','left', ...
		'String',' Parametry selekcji: ', ...
		'Style','text', ...
		'Tag','Selection1DText');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 63 120 18], ...
		'HorizontalAlignment','left', ...
		'String',' Numer cechy wasnej: ', ...
		'Style','text', ...
		'Tag','EigengeneText');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 65 105 20], ...
		'String',eigengene_string, ...
		'Style','popupmenu',...
		'Value',1, ...
		'Tag','EigengenePop', ...
		'Callback','');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 40 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'String',num2str(0.8),...
		'UserData',[0 1 0.8 0],...
		'Tag','ThresholdEdit',...
		'Callback','sel1D_svd_cb(''edit'')');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 38 100 18], ...
		'HorizontalAlignment','left', ...
		'String',' Minimalny udzia:', ...
		'Style','text', ...
		'Tag','ThresholdEditText');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
	   	'Position',[5 5 75 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
   		'Callback','delete(gcbf)');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
	   	'Position',[85 5 75 25], ...
		'String','Zapisz', ...
		'Tag','SaveButt', ...
   		'Callback','sel1D_svd_cb(''save'')');

	uicontrol('Parent',Sel1DSvd_id, ...
		'Units','pixels', ...
		'Position',[165 5 80 25], ...
		'String','Selekcja', ...
		'Tag','Selection1DButt', ...
		'CallBack','sel1D_svd_cb(''selection'')');
end;