function selND;

size_x=250;
size_y=110;

Sel_id=findobj('Tag','Selection');
if isempty(Sel_id)==0
	figure(Sel_id);
	set(Sel_id,'Position',[200 200 size_x size_y]);
else
	Array_id=findobj(0,'Tag','ArrayView');
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

	genes_count=str2num(get(findobj(Array_id,'Tag','GeneNrEdit'),'String'));

	method_string={'RFE','ANOVA'};

	Sel_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','Selekcja wielowymiarowa', ...
		'KeyPressFcn',@figure_kb_cb,...
		'Tag','Selection');

	hnd=uipanel('Parent',Sel_id, ...
		'Title','Parametry:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 240 70], ...
		'Tag','DataPanel');
	
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 30 90 18], ...
		'HorizontalAlignment','left', ...
		'String','Metoda selekcji: ', ...
		'Style','text', ...
		'Tag','MethodText');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[100 30 130 20], ...
		'String',method_string, ...
		'Style','popupmenu',...
		'Value',1, ...
		'Tag','MethodPop', ...
		'Callback','selND_cb(''pop'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 5 180 18], ...
		'HorizontalAlignment','left', ...
		'String','Liczba cech:', ...
		'Style','text', ...
		'Tag','FeaturesNrEditText');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[185 5 45 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'String',num2str(genes_count),...
		'UserData',[1 genes_count genes_count 0],...
		'Tag','FeaturesNrEdit',...
		'Callback','edit_cb');

	%%%%%%%%%%
	uicontrol('Parent',Sel_id, ...
		'Units','pixels', ...
	   	'Position',[165 5 80 25], ...
		'String','Wykonaj', ...
		'Tag','SelectionButt', ...
   		'CallBack','selND_cb(''selection'')');

	uicontrol('Parent',Sel_id, ...
		'Units','pixels', ...
	   	'Position',[80 5 80 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
   		'Callback','delete(gcbf)');
end;