function svdec_cb(action);

Array_id=findobj(0,'Tag','ArrayView');
SVD_id=findobj(0,'Tag','SVD');
EnthropyEdit_id=findobj(SVD_id,'Tag','EnthropyEdit');
ProfilePop_id=findobj(SVD_id,'Tag','ProfilePop');
PercentEdit_id=findobj(SVD_id,'Tag','PercentEdit');
PercentEdit2_id=findobj(SVD_id,'Tag','PercentEdit2');
PValueEdit_id=findobj(SVD_id,'Tag','PValueEdit');
ExpressionButt_id=findobj(SVD_id,'Tag','ExpressionButt');
ProfileButt_id=findobj(SVD_id,'Tag','ProfileButt');
ProfileEdit_id=findobj(SVD_id,'Tag','ProfileEdit');

switch action
	case 'edit'
		Edit_id=gcbo;
		num=str2num(get(Edit_id,'String'));
		limits=get(Edit_id,'UserData');

		if isempty(num)==1
			num=limits(3);
			beep;
		else
			switch limits(4)
				case 0
					if num<limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
				case 1
					if num<=limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 2
					if num<limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 3
					if num<=limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
			end;
		end;
		set(Edit_id,'String',num2str(num));

	case 'pop'
		data_struct=get(SVD_id,'UserData');
		aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');

		data_struct.eigengene_nr=get(ProfilePop_id,'Value');

		if max(aorder)>1
			p=anova1(data_struct.v(:,data_struct.eigengene_nr),aorder,'off');
		else
			p=NaN;
		end;
		set(PValueEdit_id,'String',num2str(p));
		set(SVD_id,'UserData',data_struct);

	case 'expression'
		data_struct=get(SVD_id,'UserData');
		svd_entropy([],1,0.8,data_struct.s);

	case 'percent'
		data_struct=get(SVD_id,'UserData');
		treshold=str2num(get(PercentEdit_id,'String'))/100;

		[e,p,nr]=svd_entropy([],0,treshold,data_struct.s);
		set(PercentEdit2_id,'String',num2str(nr));

	case 'find_minp'
		data_struct=get(SVD_id,'UserData');
		aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');

		if max(aorder)>1
			p=zeros(1,size(data_struct.v,2));
			for i=1:size(data_struct.v,2)
				p(i)=anova1(data_struct.v(:,i),aorder,'off');
			end;
			minp=find(p==min(p));
			set(ProfilePop_id,'Value',minp(1));
			set(PValueEdit_id,'String',num2str(p(minp(1))));

			data_struct.eigengene_nr=minp(1);
			set(SVD_id,'UserData',data_struct);
		end;

	case 'delete'
		data=get(Array_id,'UserData');
%		data=data_normalize(data_center(data,'mean'),'std');
		[u,s,v]=svd(data,0);

		eigengene_nr=get(ProfilePop_id,'Value');

		s(eigengene_nr,eigengene_nr)=0;
		data=u*s*v';
		[u,s,v]=svd(data,0);

		[enthropy,p,nr]=svd_entropy([],0,str2num(get(PercentEdit_id,'String'))/100,s);
		set(PercentEdit2_id,'String',num2str(nr));
		set(EnthropyEdit_id,'String',num2str(enthropy));

		aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
		if max(aorder)>1
			p=anova1(v(:,1),aorder,'off');
		else
			p=NaN;
		end;
		set(PValueEdit_id,'String',num2str(p));

		data_struct.u=u;
		data_struct.s=s;
		data_struct.v=v;
		data_struct.eigengene_nr=1;
		set(ProfilePop_id,'Value',1);
		set(SVD_id,'UserData',data_struct);

		set(Array_id,'UserData',data);
		mstat_cb('prepare_data');
		mstat_cb('redraw');

		figure(SVD_id);

	case 'profile'
		plot_profile;

	case 'save'
		svd_data_struct=get(gcbf,'UserData');
		eigengene_nr=get(ProfilePop_id,'Value');
		[fname,path]=uiputfile({'*.acl';'*.*'},'Zapisz do pliku');
		if fname~=0
			if isempty(strfind(fname,'.acl'))
				fname=[fname '.acl'];
			end;
			anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
			values=svd_data_struct.v(:,eigengene_nr);
			
			records=cell(length(anames),1);
			for i=1:length(records)
				line=cell(1,2);
				line{1}=anames{i};
				line{2}=num2str(values(i));
				records{i}=line;
			end;
			save_cell(records,[path fname]);
		end;
end;
