function tst1D;

size_x=320;
size_y=340;

Array_id=findobj(0,'Tag','ArrayView');
config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

Parent_id=gcbf;

switch get(Parent_id,'Tag')
	case 'ArrayView'
		data=get(Array_id,'UserData');
		
		gene_nr=str2num(get(findobj(Array_id,'Tag','SelectedGeneEdit'),'String'));
		if isempty(gene_nr)
			gene_nr=1;
		end;
		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
		gene_name=gnames{gene_nr};
		gene_nr_string='Numer cechy:';

	case 'PlotProfile'
		data=get(Array_id,'UserData');
		data_struct=get(gcbf,'UserData');
		gene_nr=data_struct.gene_nr;
		gene_name=data_struct.gene_name;
		if gene_nr>size(data,1)
			gene_nr=1;
			beep;
		end;
		gene_nr_string='Numer cechy:';
	
	case 'PlotEigengene'
		svd_data_struct=get(Parent_id,'UserData');
		data=svd_data_struct.data;
		gene_nr=svd_data_struct.eigengene_nr;
		if svd_data_struct.pc==1
			gene_name=['PC' num2str(gene_nr)];
			gene_nr_string='Nr. sk. g.:';
		else
			gene_name=['Engengene ' num2str(gene_nr)];
			gene_nr_string='Nr. cechy w.:';
		end;
end;

aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
genes_count=size(data,1);
classes_count=max(aorder);
cnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'String');

if classes_count<=2
	method_string={'ANOVA';'Kruskal-Wallis';'Satterthwaite';'Mann-Whitney'};
else
	method_string={'ANOVA';'Kruskal-Wallis'};
end;
log_string={'log2';'log10';'ln'};

Tst1D_id=figure('Units','pixels', ...
	'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
	'Color',config.bg_color, ...
	'Visible','on',...
	'MenuBar','none', ...
	'NumberTitle','off', ...
	'Resize','off',...
	'CreateFcn','set(findobj(get(0,''Child''),''Tag'',''ArrayView''),''WindowButtonMotionFcn'','''');',...
	'DeleteFcn','set(findobj(get(0,''Child''),''Tag'',''ArrayView''),''WindowButtonMotionFcn'',''mstat_mf'');',...
	'Name','Jednowymiarowe testy istotnoci', ...
	'KeyPressFcn',@figure_kb_cb,...					
	'Tag','Test1D');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[5 300 310 35], ...
	'HorizontalAlignment','left', ...
	'Enable','off',...
	'Style','frame', ...
	'Tag','DataFrame');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[10 323 35 18], ...
	'HorizontalAlignment','left', ...
	'String',' Dane: ', ...
	'Style','text', ...
	'Tag','DataFrameText');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[10 305 150 18], ...
	'String','Skala logarytmiczna ',...
	'Style','checkbox', ...
	'Value',1,...
	'Tag','LogCheck',...
	'Callback','tst1D_cb(''check'')');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[165 307 145 20], ...
	'String',log_string, ...
	'Style','popupmenu',...
	'Value',2, ...
	'Enable','on',...
	'Tag','LogPop', ...
	'Callback','tst1D_cb(''pop'')');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[5 85 310 205], ...
	'HorizontalAlignment','left', ...
	'Enable','off',...
	'Style','frame', ...
	'Tag','TestFrame');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[10 279 35 18], ...
	'HorizontalAlignment','left', ...
	'String',' Test: ', ...
	'Style','text', ...
	'Tag','TestText');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[165 260 145 20], ...
	'Style','popupmenu',...
	'String',method_string,...
	'Value',1, ...
	'Tag','MethodPop', ...
	'Callback','tst1D_cb(''test'')');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels',...
	'BackgroundColor',config.bg_color, ...
	'Position',[10 258 100 20], ...
	'HorizontalAlignment','left', ...
	'String','Rodzaj testu: ', ...
	'Style','text', ...
	'Tag','MethodText');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[10 230 280 18], ...
	'HorizontalAlignment','left', ...
	'String','Hipoteza o rwnoci wartoci rednich wsystkich klas: ', ...
	'Style','text', ...
	'Tag','TstText');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[230 205 80 20], ...
	'HorizontalAlignment','right', ...
	'Style','edit',...
	'Tag','PValEdit');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[165 204 60 18], ...
	'HorizontalAlignment','left', ...
	'String','p-value: ', ...
	'Style','text',...
	'Tag','PValEditText');

%uicontrol('Parent',Tst1D_id, ...
%	'Units','pixels', ...
%	'BackgroundColor',[1 1 1], ...
%	'Position',[245 205 65 20], ...
%	'HorizontalAlignment','right', ...
%	'Style','edit',...
%	'Tag','IQREdit');

%uicontrol('Parent',Tst1D_id, ...
%	'Units','pixels', ...
%	'BackgroundColor',config.bg_color, ...
%	'Position',[165 204 80 18], ...
%	'HorizontalAlignment','left', ...
%	'String','IQ range: ', ...
%	'Style','text',...
%	'Tag','IQREditText');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[10 175 300 18], ...
	'HorizontalAlignment','left', ...
	'String','Hipoteza o rwnoci wartoci rednich poszczeglnych klas: ', ...
	'Style','text', ...
	'Tag','FTstText');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[10 150 135 20], ...
	'Style','popupmenu',...
	'String',cnames,...
	'Value',1, ...
	'Tag','ClassPop1', ...
	'Callback','tst1D_cb(''pop'')');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels',...
	'Position',[145 150 20 20],...
	'Style','pushbutt', ...
	'String','vs',...
	'Tag','ClassButton',...
	'CallBack','tst1D_cb(''switch_pop'')');
		
uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[165 150 145 20], ...
	'Style','popupmenu',...
	'String',cnames,...
	'Value',2, ...
	'Tag','ClassPop2', ...
	'Callback','tst1D_cb(''pop'')');

	uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[80 120 65 20], ...
	'HorizontalAlignment','right', ...
	'Style','edit',...
	'Tag','FCEdit');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[10 119 70 18], ...
	'HorizontalAlignment','left', ...
	'String','Fold change: ', ...
	'Style','text',...
	'Tag','FCEditText');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[230 120 80 20], ...
	'HorizontalAlignment','right', ...
	'Style','edit',...
	'Tag','PVal2Edit');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[165 119 60 18], ...
	'HorizontalAlignment','left', ...
	'String','p-value: ', ...
	'Style','text',...
	'Tag','PVal2EditText');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
   	'Position',[80 90 65 20], ...
	'String','Boxplot', ...
	'Tag','BoxplotButt',...
	'CallBack','tst1D_cb(''boxplot'')');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
   	'Position',[165 90 70 20], ...
	'String','Histogram', ...
	'Tag','HistogramButt',...
	'CallBack','plot_hist');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
   	'Position',[245 90 65 20], ...
	'String','Q-Q', ...
	'Tag','QQPlotButt',...
	'CallBack','');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[5 35 310 40], ...
	'HorizontalAlignment','left', ...
	'Enable','off',...
	'Style','frame', ...
	'Tag','ParamFrame');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[10 64 60 18], ...
	'HorizontalAlignment','left', ...
	'String',' Parametry: ', ...
	'Style','text', ...
	'Tag','ParamFrameText');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[95 45 60 20], ...
	'HorizontalAlignment','right', ...
	'Style','edit', ...
	'String',num2str(gene_nr),...
	'UserData',[1 genes_count 1 0],...
	'Tag','GeneNrEdit',...
	'Callback','tst1D_cb(''edit'')');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[10 44 70 18], ...
	'HorizontalAlignment','left', ...
	'String',gene_nr_string, ...
	'Style','text', ...
	'Tag','GeneNrEditText');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[250 45 60 20], ...
	'HorizontalAlignment','right', ...
	'Style','edit',...
	'String',num2str(0.05),...
	'UserData',[0 1 0.05 1],...
	'Tag','AlfaEdit',...
	'Callback','tst1D_cb(''edit'')');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
	'BackgroundColor',config.bg_color, ...
	'Position',[165 44 80 18], ...
	'HorizontalAlignment','left', ...
	'String','Poziom ufnoci: ', ...
	'Style','text', ...
	'Tag','AlfaEditText');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
   	'Position',[5 5 80 25], ...
	'String','p-values', ...
	'Tag','PValButt',...
	'CallBack','plot_pval');
	
uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
   	'Position',[235 5 80 25], ...
	'String','Wykonaj', ...
	'Tag','TestButt',...
	'CallBack','tst1D_cb(''test'')');

uicontrol('Parent',Tst1D_id, ...
	'Units','pixels', ...
   	'Position',[145 5 80 25], ...
	'String','Zamknij', ...
	'Tag','CancelButt', ...
	'Callback','delete(gcbf);');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if strcmp(get(Parent_id,'Tag'),'PlotEigengene')
	data_struct.eigen=1;
	data_struct.data=data;
else
	data_struct.eigen=0;
	data_struct.data=[];
end;
set(Tst1D_id,'UserData',data_struct);

tst1D_cb('test',Tst1D_id);
return;