function [data,genes_order,arrays_order,genes_names,arrays_names,groups_names,classes_names,genes_list,dataset_name,path]=load_raw(def_path);

Array_id=findobj(get(0,'Child'),'Tag','ArrayView');
if ~isempty(Array_id)
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');
	
	set(Array_id,'WindowButtonMotionFcn','');
	set(Array_id,'Pointer','watch');
	drawnow;
else
	config=[];
end;


if nargin==0 || isempty(def_path)
	if ~isempty(config)
		def_path=config.open_path;
	else
		def_path=[pwd filesep];
	end;
end;

[fname,path]=uigetfile('*.txt','Otwrz plik',def_path);
file=[path,fname];
if file==0
	dataset_name=[];

	data=[];
	arrays_order=[];
	arrays_names=[];
	classes_names=[];

	genes_order=[];
	genes_names=[];
	groups_names=[];
	genes_list=[];
	dataset_name=[];
	path=[];
	return;
end;



%%%%%%%%wczytanie pliku z danymi%%%%%%%%%%%%%
%tic
dataset=load_table([path fname]);
%toc

%dataset.data=flipud(dataset.data);
%dataset.row_names=flipud(dataset.row_names);

data=dataset.data;
if isempty(data)
	dataset_name=[];

	data=[];
	arrays_order=[];
	arrays_names=[];
	classes_names=[];

	genes_order=[];
	genes_names=[];
	groups_names=[];
	genes_list=[];
	dataset_name=[];
	path=[];
	return;
end;

dimension=size(data,1);
vectors_count=size(data,2);

if strcmp(dataset.name,'NAME')==1
	dataset_name=fname(1:length(fname)-4);
else
	dataset_name=dataset.name;
end;

arrays_names=dataset.column_names;
if isempty(arrays_names)
	arrays_names=cell(vectors_count,1);
	for i=1:vectors_count
		arrays_names{i}=['Prbka ' num2str(i)];
	end;
end;

if isempty(dataset.column_classes)
	arrays_order=ones(vectors_count,1);
else
	arrays_order=reorder_labels(dataset.column_classes);
end;

classes_count=max(arrays_order);
if isempty(dataset.column_classes) | length(dataset.class_names)~=classes_count
	classes_names=cell(classes_count,1);
	if classes_count==1
		classes_names{1}='Brak podziau na klasy';
	else
		for i=1:classes_count
			classes_names{i}=['Klasa' num2str(i)];
		end;
	end;
else
	classes_names=dataset.class_names;
end;

genes_names=dataset.row_names;
if isempty(genes_names)
	genes_names=cell(dimension,1);
	for i=1:dimension
		genes_names{i}=['Cecha ' num2str(i)];
	end;
end;

if (length(unique(genes_names))~=length(genes_names))
	warning('Zbir danych zawiera cechy o nieunikalnych nazwach.');
end;

genes_list=(1:dimension)';

fname=fname(1:length(fname)-4);

%%%%%%%%wczytanie pliku z podziaem na grupy cech%%%%%%%%%
records=load_cell2([path fname '.gcl']);
genes_order=ones(dimension,1);

if size(records,1)==dimension & size(records,2)==1
	for i=1:dimension
		record=records{i};
		if length(record)<2
			break;
		end;
		genes_order(i)=str2num(record{2});

	end;
end;
genes_order=reorder_labels(genes_order);
%genes_order=flipud(genes_order);

%%%%%%%%wczytanie pliku z nazwami grup cech%%%%%%%%
[groups_names,groups_count]=load_cell([path fname '.gcn']);
if groups_count~=max(genes_order)
	clear groups_names;
	groups_count=max(genes_order);

	groups_names=cell(groups_count,1);
	if groups_count==1
		groups_names{1}='Brak podziau na grupy';
	else
		for i=1:groups_count
			groups_names{i}=['Grupa' num2str(i)];
		end;
	end;
end;

%aa(data,genes_order,genes_names,groups_names);

