function plot_box_cb(action,fig);

if nargin==1
	PlotBox_id=gcbf;
else
	PlotBox_id=fig;
end;


PlotAxes_id=findobj(PlotBox_id,'Tag','PlotAxes');
ScaleSubmenu_id=findobj(PlotBox_id,'Tag','ScaleSubmenu');

switch action
	case 'save'
		data_struct=get(PlotBox_id,'UserData');
		figsave_cb(0,[data_struct.name '_box']);

	case 'scale'
		selected=gcbo;
		set(get(ScaleSubmenu_id,'Child'),'Check','off');
		set(selected,'Check','on');

		data_struct=get(PlotBox_id,'UserData');
		log_base=str2num(get(selected,'Tag'));
		if log_base~=data_struct.log_base
			data_struct.log_base=log_base;
			set(PlotBox_id,'UserData',data_struct);
			plot_box_cb('redraw');
		end;

	case 'redraw'
		data_struct=get(PlotBox_id,'UserData');
		data=data_struct.data;

		axes(PlotAxes_id);
		delete(findobj(PlotAxes_id,'Type','patch'));

		if ~isempty(data_struct.aorder)
			index=find(isnan(data)==0);
			if length(index)>=1
				switch data_struct.log_base
					case 2
						data(index)=log2(data(index));
					case 10
						data(index)=log10(data(index));
					case {-2,-10}
						data(index)=(-1*data_struct.log_base).^data(index);
				end;
				boxplot(data(index),data_struct.aorder(index),'notch','off','symbol','o','labels',data_struct.cnames(unique(data_struct.aorder(index))));
			end;
		else
			boxplot(data,'notch','off','symbol','o','labels',data_struct.cnames);
		end;

		set(PlotAxes_id,'Tag','PlotAxes','FontSize',9); %,'FontWeight','bold' 'Position',[60 40 565 360]
		if isVersion(7.5)>0
			set(PlotAxes_id,'Position',[60 40 565 360]);
		end;
		xlabel('');
		ylabel('Expression level');
%		ylabel('Relative abundance');

end;