function plot_centroids;

Array_id=findobj(0,'Tag','ArrayView');
data=get(Array_id,'UserData');

gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'String');
groups_count=max(gorder);
vectors_count=size(data,2);

PlotCentroids_id=figure('Units','pixels',...
			'Visible','on',...
			'Color',get(0,'defaultUicontrolBackgroundColor'),...
			'NumberTitle','off',...
			'MenuBar','none',...
			'KeyPressFcn',@figure_kb_cb,...				
			'Tag','PlotCentroids');


FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','figsave_cb');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

ViewMenu_id=uimenu('Label','&Widok','Tag','View');
ViewPlotMenu_id=uimenu(ViewMenu_id,'Label','Rodzaj wykresu','Tag','PlotMenu');
uimenu(ViewPlotMenu_id,'Label','Liniowy','Checked','on','Tag','LinePlot','CallBack','plot_centroids_cb(''plot_type'')','UserData','line');
uimenu(ViewPlotMenu_id,'Label','Liniowy urediony','Checked','off','Tag','LinePlot','CallBack','plot_centroids_cb(''plot_type'')','UserData','meanline');
uimenu(ViewPlotMenu_id,'Label','Supkowy','Enable','off','Tag','BarPlot','CallBack','plot_centroids_cb(''plot_type'')','UserData','bar');
uimenu(ViewPlotMenu_id,'Label','Supkowy uredniony','Enable','off','Tag','BarPlot','CallBack','plot_centroids_cb(''plot_type'')','UserData','meanbar');

ViewThresholdMenu_id=uimenu(ViewMenu_id,'Label','Progi','Tag','PlotThreshold');
uimenu(ViewThresholdMenu_id,'Label','Rysuj progi','Checked','off','CallBack','plot_centroids_cb(''plot_thresholds'')');
uimenu(ViewThresholdMenu_id,'Label','Grny','Separator','on','Tag','ThresholdUp','CallBack','plot_centroids_cb(''set_thresholds'')');
uimenu(ViewThresholdMenu_id,'Label','Dolny','Tag','ThresholdDown','CallBack','plot_centroids_cb(''set_thresholds'')');

ViewGroupMenu_id=uimenu(ViewMenu_id,'Label','Grupa','Tag','GroupMenu');
uimenu(ViewGroupMenu_id,'Label','Wszystkie (osobno)','CallBack','plot_centroids_cb(''group'')','UserData',-1);
hnd=uimenu(ViewGroupMenu_id,'Label','Wszystkie (wsplnie)','Checked','on','CallBack','plot_centroids_cb(''group'')','UserData',0);
if groups_count>1
	for i=1:groups_count
		hnd=uimenu(ViewGroupMenu_id,'Label',gcnames{i},'Callback','plot_centroids_cb(''group'')','UserData',i);
		if i==1
			set(hnd,'Separator','on');
		end;
	end;
end;
ViewMeanMenu_id=uimenu(ViewMenu_id,'Label','rednia','Tag','MeanMenu');
uimenu(ViewMeanMenu_id,'Label','&Arytmetyczna','Tag','AMean','Checked','on','CallBack','plot_centroids_cb(''centroid_type'')','UserData','mean');
hnd=uimenu(ViewMeanMenu_id,'Label','&Geometryczna','Tag','GMean','CallBack','plot_centroids_cb(''centroid_type'')','UserData','gmean');
if min(data(:))<0
	set(hnd,'Enable','off')
end;
uimenu(ViewMeanMenu_id,'Label','&Mediana','Tag','Median','CallBack','plot_centroids_cb(''centroid_type'')','UserData','median');
uimenu(ViewMenu_id,'Label','&Normalizacja','Tag','Norm','Separator','on','CallBack','plot_centroids_cb(''norm'')');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
centroids=zeros(groups_count,vectors_count);
dispersion=0;
for i=1:groups_count;
	cluster_vectors_list=find(gorder==i);
	
	if ~isempty(cluster_vectors_list)
		centroids(i,:)=mean(data(cluster_vectors_list,:));
		dispersion=dispersion+sum(cluster_distance(centroids(i,:)',data(cluster_vectors_list,:)','correlation',0));
	end;
end;

data_struct.centroids=centroids;
data_struct.aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
data_struct.position=get(PlotCentroids_id,'Position');
data_struct.acnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'String');
data_struct.normalize=0;
data_struct.selected=0;
data_struct.plot_thresholds=0;
data_struct.threshold1=NaN;
data_struct.threshold2=NaN;
data_struct.plot='line';
data_struct.color=ctable;
colors_count=size(data_struct.color,1);

set(PlotCentroids_id,'UserData',data_struct);
set(PlotCentroids_id,'Name','Profile ekspresji centoidw grup');
plot_centroids_cb('redraw',PlotCentroids_id);