function plot_profiles_cb(action);

PlotCorr_id=gcbf;

Array_id=findobj(0,'Tag','ArrayView');
if ~isempty(Array_id)
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');
	name=get(Array_id,'Name');
	defname=[name(strfind(name,'-')+2:length(name)) '_corr'];
else
	config.export_path='.';
	defname='noname_corr';
end;

switch action
	case 'save'
		ext_str={'png';'bmp';'jpg';'tif'};
		format_str={'png';'bmp';'jpg';'tiff'};
		
		[name,path,format]=uiputfile({'*.png','Plik PNG (*.png)';'*.bmp','Plik BMP (*.bmp)';'*.jpg','Plik JPEG (*.jpg)';'*.tif','Plik TIFF (*.tif)';'*.*','Wszystkie pliki (*.*)'},'Zapisz obraz do pliku',[config.export_path defname]);
		if name~=0
			[filename,format]=getfname(name,path,format,ext_str);
			
			corr_image=ind2rgb(get(findobj(findobj(PlotCorr_id,'Tag','CorrAxes'),'Tag','CorrImage'),'CData'),get(PlotCorr_id,'Colormap'));
			order=get(findobj(PlotCorr_id,'Tag','XAxes'),'UserData');
			vectors_count=length(order);

			color=ctable;

			xorder_image=zeros(1,vectors_count,3);
			yorder_image=zeros(vectors_count,1,3);
			for i=1:max(order)
				ind=find(order==i);
				for j=1:3
					xorder_image(1,ind,j)=color(i,j);
					yorder_image(ind,1,j)=color(i,j);
				end;
			end;
			xorder_image=repmat(xorder_image,6,1);
			yorder_image=repmat(yorder_image,1,6);

			image=ones(vectors_count+9,vectors_count+9,3);
			image(9:vectors_count+8,9:vectors_count+8,1:3)=corr_image;
			image(2:7,9:vectors_count+8,1:3)=xorder_image;
			image(9:vectors_count+8,2:7,1:3)=yorder_image;

			imwrite(imresize(image,[400 400],'nearest'),filename,format_str{format});
%			imwrite(image,filename,format_str{format});
		end;

	case 'set_lut'
		hnd=findobj(PlotCorr_id,'Tag','ViewLUTSubMenu');
		set(get(hnd,'Child'),'Checked','off');
		set(gcbo,'Checked','on');

		cmap=lut(get(gcbo,'Tag'),256,256);
		set(PlotCorr_id,'Colormap',cmap);
		drawnow;

	case 'invert_lut'
		cmap=get(PlotCorr_id,'Colormap');
		cmap(1:255,:)=flipud(cmap(1:255,:));

		set(PlotCorr_id,'Colormap',cmap);
		drawnow;

	case 'exit'
		delete(PlotCorr_id);
	
end;