function plot_cv(data,mode,metric,name);

if nargin<1
	error('The function needs al least one argument');
end;

if nargin==1
	mode='box';
	metric='cv';
	name='';
end;
if nargin==2
	metric='cv';
	name='';
end;
if nargin==3
	name='';
end;

switch questdlg('Czy wartoci s zlogarytmowane?','MStat','Tak','Nie','Anuluj','Tak')
	case 'Tak'
		switch questdlg('Podaj podstaw logarytmu','MStat','log_2','log_10','log_e','log_2')
			case 'log_2'
				logbase=2;
			case 'log_10'
				logbase=10;
			case 'log_e'
				logbase=exp(1);
			otherwise
				return;
		end;

	case 'Nie'
		logbase=0;
	otherwise
		return;
end;

screen=get(0,'Screensize');
screen_x=screen(3);
screen_y=screen(4);

size_x=630;
size_y=475;
pos_x=(screen_x-size_x)/2;
pos_y=(screen_y-size_y)/2;

PlotCV_id=figure('Units','pixels',...
			'Position',[pos_x pos_y size_x size_y],...
			'Color',get(0,'defaultUicontrolBackgroundColor'),...
			'Visible','on',...
			'NumberTitle','off',...
			'MenuBar','none',...
			'Resize','off',...
			'KeyPressFcn',@figure_kb_cb,...							
			'Tag','PlotCV');

PlotAxes_id=axes('Parent',PlotCV_id,...
		'Units','pixels',...
		'FontSize',8,...
		'Position',[60 90 565 360],...
		'Tag','PlotAxes');

InfoEdit_id=uicontrol('Parent',PlotCV_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[60 5 565 65], ...
		'HorizontalAlignment','left', ...
		'String','',...
		'FontName','Courier',...
		'Max',5,...
		'Style','edit', ...
		'Tag','InfoEdit');

%
%Menu
%
FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','plot_cv_cb(''save'')');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

hnd=[];
DataMenu_id=uimenu('Label','&Dane','Tag','DataMenu');
hnd=uimenu(DataMenu_id,'Label','&SD/Mean','CallBack','plot_cv_cb(''change_metric'')','Tag','cv');
if strcmp(metric,'cv')==1
	set(hnd,'Check','on');
end;
hnd=uimenu(DataMenu_id,'Label','&MAD/median','CallBack','plot_cv_cb(''change_metric'')','Tag','meddev');
if strcmp(metric,'maddev')==1
	set(hnd,'Check','on');
end;
hnd=uimenu(DataMenu_id,'Label','&IQR/median','CallBack','plot_cv_cb(''change_metric'')','Tag','iqrange');
if strcmp(metric,'maddev')==1
	set(hnd,'Check','on');
end;

ViewMenu_id=uimenu('Label','&Widok','Tag','ViewMenu');
hnd=uimenu(ViewMenu_id,'Label','&Boxplot','separator','on','CallBack','plot_cv_cb(''change_mode'')','Tag','box');
if strcmp(mode,'box')==1
	set(hnd,'Check','on');
end;
hnd=uimenu(ViewMenu_id,'Label','&Histogram','CallBack','plot_cv_cb(''change_mode'')','Tag','hist');
if strcmp(mode,'hist')==1
	set(hnd,'Check','on');
end;
hnd=uimenu(ViewMenu_id,'Label','&Posortowane wartoci','CallBack','plot_cv_cb(''change_mode'')','Tag','sort');
if strcmp(mode,'sort')==1
	set(hnd,'Check','on');
end;
hnd=uimenu(ViewMenu_id,'Label','&CV vs. rednia','CallBack','plot_cv_cb(''change_mode'')','Tag','cvm');
if strcmp(mode,'cvm')==1
	set(hnd,'Check','on');
end;

pause(0.01);
set(findobj(0,'Tag','ArrayView'),'Pointer','watch');
set(PlotCV_id,'Pointer','watch');
pause(0.01);

if logbase~=0
	data=logbase.^data;
end;

m=nan_mean(data,2);
sd=nan_sd(data,2);
iqrange=nan_iqr(data,2);
med=nan_median(data,2);
meddev=nan_mad(data,2);

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
data_struct.sd=sd;
data_struct.m=m;
data_struct.iqrange=iqrange;
data_struct.med=med;
data_struct.meddev=meddev;
data_struct.metric=metric;
data_struct.mode=mode;
data_struct.name=name;
set(PlotCV_id,'UserData',data_struct);
plot_cv_cb('redraw',PlotCV_id);

set(findobj(0,'Tag','ArrayView'),'Pointer','arrow');
set(PlotCV_id,'Pointer','arrow');