function plot_hist();

PlotHistogram_id=figure('Units','pixels',...
			'Visible','on',...
			'Color',get(0,'defaultUicontrolBackgroundColor'),...
			'NumberTitle','off',...
			'MenuBar','none',...
			'Resize','off',...
			'KeyPressFcn',@figure_kb_cb,...
			'Tag','PlotHistogram');

FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','figsave_cb');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

ViewMenu_id=uimenu('Label','&Widok');
uimenu(ViewMenu_id,'Label','Liczba przedziaw','CallBack','plot_hist_cb(''bins_count'')');
uimenu(ViewMenu_id,'Label','Histogram','Separator','on','Checked','on','CallBack','plot_hist_cb(''histogram'')');

ViewKDEMenu_id=uimenu(ViewMenu_id,'Label','&Kernel density','Tag','KDESubmenu');
uimenu(ViewKDEMenu_id,'Label','Normal','Checked','off','CallBack','plot_hist_cb(''kernel_density'')','Tag','normal');
uimenu(ViewKDEMenu_id,'Label','Triangle','Checked','off','CallBack','plot_hist_cb(''kernel_density'')','Tag','triangle');
uimenu(ViewKDEMenu_id,'Label','Box','Checked','off','CallBack','plot_hist_cb(''kernel_density'')','Tag','box');
uimenu(ViewKDEMenu_id,'Label','Epanechnikov','Checked','off','CallBack','plot_hist_cb(''kernel_density'')','Tag','epanechnikov');

ViewFitMenu_id=uimenu(ViewMenu_id,'Label','&Dopasowanie','Tag','FitSubmenu');
uimenu(ViewFitMenu_id,'Label','1 x Gauss','Check','off','CallBack','plot_hist_cb(''fit'')','Tag','singlenormal');
uimenu(ViewFitMenu_id,'Label','GCRMA (2 x gauss)','Separator','on','Check','off','CallBack','plot_hist_cb(''fit'')','Tag','doublenormal');
uimenu(ViewFitMenu_id,'Label','GCRMA (3 x gauss)','Check','off','CallBack','plot_hist_cb(''fit'')','Tag','triplenormal');
uimenu(ViewFitMenu_id,'Label','GCRMA (4 x gauss)','Check','off','CallBack','plot_hist_cb(''fit'')','Tag','quadnormal');

Array_id=findobj(0,'Tag','ArrayView');
set(Array_id,'Pointer','watch');
pause(0.01);

title_str='Histogram: ';
bins_count=100;

switch get(gcbf,'Tag')
	case 'ArrayView'
		data=get(Array_id,'UserData');

		switch get(gcbo,'Tag')
			case 'DataHist'
				hist_data=data(:);
				title_str=[title_str 'wszystkie wartoci w zbiorze danych'];
			case 'GeneHist'
				gene_nr=str2num(get(findobj(Array_id,'Tag','SelectedGeneEdit'),'String'));
				if ~isempty(gene_nr)
					hist_data=data(gene_nr,:);

					gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
					title_str=[title_str gnames{gene_nr}];
					bins_count=round(length(hist_data)/3);
				else
					close(PlotHistogram_id);
					set(Array_id,'Pointer','arrow');
					errordlg('Nie zostaa wybrana adna cecha','MStat');
					return;
				end;

			case 'ArrayHist'
				array_nr=str2num(get(findobj(Array_id,'Tag','SelectedArrayEdit'),'String'));
				if ~isempty(array_nr)
					hist_data=data(:,array_nr);

					anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
					title_str=[title_str anames{array_nr}];
				else
					close(PlotHistogram_id);
					set(Array_id,'Pointer','arrow');
					errordlg('Nie zostaa wybrana adna prbka','MStat');
					return;
				end;
		end;

	case 'Adjust'
		data=get(Array_id,'UserData');
		
		hist_data=data(:);
		title_str=[title_str 'wszystkie wartoci w zbiorze danych'];

	case 'Test1D'
		Tst1D_id=gcbf;
		data_struct=get(Tst1D_id,'UserData');
		gene_nr=str2num(get(findobj(Tst1D_id,'Tag','GeneNrEdit'),'String'));

		if data_struct.eigen==0
			data=get(Array_id,'UserData');
			gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
			gene_name=gnames{gene_nr};
		else
			data=data_struct.data;
			gene_name=['Engengene ' num2str(gene_nr)];
		end;
		hist_data=data(gene_nr,:);
		title_str=[title_str gene_name];
		bins_count=round(length(hist_data)/3);
end;

[counts,points]=hist(hist_data,bins_count);

bar(points,counts,'hist');

data_struct.hist_plot=1;
data_struct.data=hist_data;
data_struct.bins_count=bins_count;
data_struct.points=points;
data_struct.counts=counts;
data_struct.fit_plot=0;
data_struct.fit=[];
data_struct.fit_type='doublenormal';
data_struct.kde_plot=0;
data_struct.kde=[];
data_struct.kde_points=[];
data_struct.kde_type='normal';

set(PlotHistogram_id,'Name',title_str,'UserData',data_struct);
set(gca,'box','on','XLim',[min(hist_data) max(hist_data)],'FontName','Arial CE','FontSize',9);
xlabel('Wartoci');
ylabel('Liczba wystpie');
set(Array_id,'Pointer','arrow');
return;
