function plot_hist_cb(action);

PlotHistogram_id=gcbf;
Array_id=findobj(0,'Tag','ArrayView');

FitSubmenu_id=findobj(PlotHistogram_id,'Tag','FitSubmenu');
KDESubmenu_id=findobj(PlotHistogram_id,'Tag','KDESubmenu');

switch action
	case 'bins_count'
		data_struct=get(PlotHistogram_id,'UserData');

		bins_count=inputdlg('Liczba przedziaw:','MStat',1,cellstr(num2str(data_struct.bins_count)));
		if isempty(bins_count)
			return;
		else
			bins_count=str2num(char(bins_count));
			if bins_count~=data_struct.bins_count
				data_struct.bins_count=bins_count;

				[data_struct.counts,data_struct.points]=hist(data_struct.data,data_struct.bins_count);
				set(PlotHistogram_id,'UserData',data_struct);
				plot_hist_cb('redraw');
			end;
		end;

	case 'histogram'
		data_struct=get(PlotHistogram_id,'UserData');

		switch get(gcbo,'Checked')
			case 'on'
				data_struct.hist_plot=0;
				set(gcbo,'Checked','off');
			case 'off'
				data_struct.hist_plot=1;
				set(gcbo,'Checked','on');
		end;
		set(PlotHistogram_id,'UserData',data_struct);
		plot_hist_cb('redraw');

	case 'kernel_density'
		data_struct=get(PlotHistogram_id,'UserData');

		checked=get(gcbo,'Checked');
		set(get(KDESubmenu_id,'Child'),'Check','off');

		switch checked
			case 'on'
				data_struct.kde_plot=0;
				set(gcbo,'Checked','off');
			case 'off'
				data_struct.kde_plot=1;
				data_struct.kde_type=get(gcbo,'Tag');

				[f,xi]=ksdensity(data_struct.data,'kernel',data_struct.kde_type);
%				data_struct.kde=f*max(data_struct.counts)/max(f);
				data_struct.kde=f;
				data_struct.kde_points=xi;

				set(gcbo,'Checked','on');
		end;
		set(PlotHistogram_id,'UserData',data_struct);
		plot_hist_cb('redraw');

	case 'fit'
		data_struct=get(PlotHistogram_id,'UserData');

		checked=get(gcbo,'Checked');
		set(get(FitSubmenu_id,'Child'),'Check','off');

		switch checked
			case 'on'
				data_struct.fit_plot=0;
				set(gcbo,'Checked','off');
			case 'off'
				data_struct.fit_plot=1;
				data_struct.fit_type=get(gcbo,'Tag');

				ismissing=isnan(data_struct.data);
				data_struct.f=get_fit(data_struct.data(ismissing==0),data_struct.points,data_struct.counts,data_struct.fit_type);

				set(gcbo,'Checked','on');
		end;
		set(PlotHistogram_id,'UserData',data_struct);
		plot_hist_cb('redraw');

	case 'redraw'
		set(Array_id,'Pointer','watch');
		pause(0.01);

		data_struct=get(PlotHistogram_id,'UserData');

		delete(findobj(gca,'Type','line'));
		delete(findobj(gca,'Type','patch'));
		delete(findobj(gca,'Type','text'));

		hold on;
		if data_struct.hist_plot==1
			bar(data_struct.points,data_struct.counts,'hist');
		end;

		if data_struct.fit_plot==1
			f=data_struct.f;
			t=[];

			switch data_struct.fit_type
				case 'quadnormal'
					fun1=f.m(1)*exp(-(data_struct.points-f.m(5)).^2/(2*f.m(9)^2))+f.m(2)*exp(-(data_struct.points-f.m(6)).^2/(2*f.m(10)^2))+f.m(3)*exp(-(data_struct.points-f.m(7)).^2/(2*f.m(11)^2));
					fun2=f.m(4)*exp(-(data_struct.points-f.m(8)).^2/(2*f.m(12)^2));
					
					hnd=plot(data_struct.points,(fun1+fun2));
					set(hnd,'LineWidth',2,'Color',[0.5 0.5 0.5]);

					hnd=plot(data_struct.points,fun1,'r');
					set(hnd,'LineWidth',2);

					hnd=plot(data_struct.points,fun2,'g');
					set(hnd,'LineWidth',2);

					fun=fun2-fun1;
					fun(find(data_struct.points<f.m(5)))=0;
					p=find(fun>0);
					t=data_struct.points(p(1));

				case 'triplenormal'
					fun1=f.m(1)*exp(-(data_struct.points-f.m(4)).^2/(2*f.m(7)^2))+f.m(2)*exp(-(data_struct.points-f.m(5)).^2/(2*f.m(8)^2));
					fun2=f.m(3)*exp(-(data_struct.points-f.m(6)).^2/(2*f.m(9)^2));

					hnd=plot(data_struct.points,(fun1+fun2));
					set(hnd,'LineWidth',2,'Color',[0.5 0.5 0.5]);
					
					hnd=plot(data_struct.points,fun1,'r');
					set(hnd,'LineWidth',2);

					hnd=plot(data_struct.points,fun2,'g');
					set(hnd,'LineWidth',2);

					fun=fun2-fun1;
					fun(find(data_struct.points<f.m(4)))=0;
					p=find(fun>0);
					t=data_struct.points(p(1));

				case 'doublenormal'
					fun1=f.m(1)*exp(-(data_struct.points-f.m(3)).^2/(2*f.m(5)^2));
					fun2=f.m(2)*exp(-(data_struct.points-f.m(4)).^2/(2*f.m(6)^2));

					hnd=plot(data_struct.points,(fun1+fun2));
					set(hnd,'LineWidth',2,'Color',[0.5 0.5 0.5]);

					hnd=plot(data_struct.points,fun1,'r');
					set(hnd,'LineWidth',2);

					hnd=plot(data_struct.points,fun2,'g');
					set(hnd,'LineWidth',2);

					fun=fun2-fun1;
					fun(find(data_struct.points<f.m(3)))=0;
					p=find(fun>0);
					t=data_struct.points(p(1));

				case 'singlenormal'
					hnd=plot(data_struct.points,f.m(1)*exp(-(data_struct.points-f.m(2)).^2/(2*f.m(3)^2)),'r');
					set(hnd,'LineWidth',2);
			end;
			ylim=get(gca,'YLim');
			text_x=data_struct.points(1)+0.7*(data_struct.points(end)-data_struct.points(1));
			text_y=ylim(1)+0.95*(ylim(2)-ylim(1));
			text(text_x,text_y,['R=' num2str(f.r)]);
			if ~isempty(t)
				text_y=ylim(1)+0.85*(ylim(2)-ylim(1));
				text(text_x,text_y,['T=' num2str(t)]);
			end;
		end;

		if data_struct.kde_plot==1
			hnd=plot(data_struct.kde_points,data_struct.kde*max(data_struct.counts)/max(data_struct.kde),'r');
			set(hnd,'LineWidth',2);
		end;
		hold off;

		set(gca,'FontSize',8,'box','on','XLim',[min(data_struct.data) max(data_struct.data)]);
		set(Array_id,'Pointer','arrow');
		drawnow;
end;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function f=get_fit(data,points,counts,fit_type)

switch fit_type
	case 'quadnormal'
		max1=max(counts(find(points<4)));
		a1=1;
		m1=points(find(counts==max1));
		s1=0.2;

		a2=0.5;
		m2=m1+0.3;
		s2=0.2;

		a3=0.3;
		m3=m2+0.3;
		s3=0.2;

		max4=max(counts(find(points>4)));
		a4=max4/max1;
		m4=points(find(counts==max4));
		s4=2;

		fun='a_1*exp(-(x-m_1)^2/(2*s_1^2)) + a_2*exp(-(x-m_2)^2/(2*s_2^2)) + a_3*exp(-(x-m_3)^2/(2*s_3^2)) + a_4*exp(-(x-m_4)^2/(2*s_4^2))';
		fun=[fun ';' 'a_1=' num2str(a1) ';' 'm_1=' num2str(m1) ';' 's_1=' num2str(s1)];
		fun=[fun ';' 'a_2=' num2str(a2) ';' 'm_2=' num2str(m2) ';' 's_2=' num2str(s2)];
		fun=[fun ';' 'a_3=' num2str(a3) ';' 'm_3=' num2str(m3) ';' 's_3=' num2str(s3)];
		fun=[fun ';' 'a_4=' num2str(a4) ';' 'm_4=' num2str(m4) ';' 's_3=' num2str(s4)];

		f=ezfit(points,counts/max(counts),fun);

		f.m(1:4)=max1*f.m(1:4);
		f.y=max1*f.y;

	case 'triplenormal'
		max1=max(counts(find(points<4)));
		a1=1;
		m1=points(find(counts==max1));
		s1=0.2;

		a2=0.5;
		m2=m1+0.3;
		s2=0.2;

		max3=max(counts(find(points>4)));
		a3=max3/max1;
		m3=points(find(counts==max3));
		s3=2;

		fun='a_1*exp(-(x-m_1)^2/(2*s_1^2)) + a_2*exp(-(x-m_2)^2/(2*s_2^2)) + a_3*exp(-(x-m_3)^2/(2*s_3^2))';
		fun=[fun '; a_1=' num2str(a1) '; m_1=' num2str(m1) '; s_1=' num2str(s1)];
		fun=[fun '; a_2=' num2str(a2) '; m_2=' num2str(m2) '; s_2=' num2str(s2)];
		fun=[fun '; a_3=' num2str(a3) '; m_3=' num2str(m3) '; s_3=' num2str(s3)];

		f=ezfit(points,counts/max(counts),fun);

		f.m(1:3)=max1*f.m(1:3);
		f.y=max1*f.y;

	case 'doublenormal'
		max1=max(counts(find(points<4)));
		a1=1;
		m1=points(find(counts==max1));
		s1=0.2;

		max2=max(counts(find(points>4)));
		a2=max2/max1;
		m2=points(find(counts==max2));
		s2=2;

		fun='a_1*exp(-(x-m_1)^2/(2*s_1^2)) + a_2*exp(-(x-m_2)^2/(2*s_2^2));';
		fun=[fun '; a_1=' num2str(a1) '; m_1=' num2str(m1) '; s_1=' num2str(s1)];
		fun=[fun '; a_2=' num2str(a2) '; m_2=' num2str(m2) '; s_2=' num2str(s2)];

		f=ezfit(points,counts/max(counts),fun);

		f.m(1:2)=max1*f.m(1:2);
		f.y=max1*f.y;

	case 'singlenormal'
		max1=max(counts);
		a1=1;
		m1=mean(data);
		s1=sqrt(var(data));
		
		fun='a_1*exp(-(x-m_1)^2/(2*s_1^2))';
		fun=[fun '; a_1=' num2str(a1) '; m_1=' num2str(m1) '; s_1=' num2str(s1)];

		f=ezfit(points,counts/max1,fun);

		f.m(1)=max1*f.m(1);
		f.y=max1*f.y;
end;
return;