function plot_profile;

screen=get(0,'Screensize');
screen_x=screen(3);
screen_y=screen(4);

size_x=630;
size_y=425;
pos_x=(screen_x-size_x)/2;
pos_y=(screen_y-size_y)/2;


PlotProfile_id=figure('Units','pixels',...
			'Position',[pos_x pos_y size_x size_y],...
			'Color',get(0,'defaultUicontrolBackgroundColor'),...
			'Visible','on',...
			'NumberTitle','off',...
			'MenuBar','none',...
			'Resize','off',...
			'KeyPressFcn',@figure_kb_cb,...			
			'Tag','PlotProfile');

PlotAxes_id=axes('Parent',PlotProfile_id,...
		'Units','pixels',...
		'FontSize',8,...
		'Position',[60 40 565 360],...
		'Tag','PlotAxes');

EditFrame_id=uipanel('Parent',PlotProfile_id, ...
		'Title','', ...
		'Units','pixels', ...
		'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
		'Position',[60 5 565 30], ...
		'Tag','EditPanel');
		
uicontrol('Parent',EditFrame_id, ...
	'Units','pixels', ...
	'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
	'Position',[5 3 70 18], ...
	'HorizontalAlignment','left', ...
	'String','Nazwa prbki: ', ...
	'Style','text', ...
	'Tag','ArrayNameText');

uicontrol('Parent',EditFrame_id, ...
	'Units','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[80 5 150 20], ...
	'HorizontalAlignment','right', ...
	'String','',...
	'Style','edit', ...
	'Tag','ArrayNameEdit');

uicontrol('Parent',EditFrame_id, ...
	'Units','pixels', ...
	'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
	'Position',[235 3 50 18], ...
	'HorizontalAlignment','left', ...
	'String','Klasa: ', ...
	'Style','text', ...
	'Tag','ClassNameText');

uicontrol('Parent',EditFrame_id, ...
	'Units','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[270 5 150 20], ...
	'HorizontalAlignment','right', ...
	'String','',...
	'Style','edit', ...
	'Tag','ClassNameEdit');

uicontrol('Parent',EditFrame_id, ...
	'Units','pixels', ...
	'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
	'Position',[425 3 50 18], ...
	'HorizontalAlignment','left', ...
	'String','Warto: ', ...
	'Style','text', ...
	'Tag','ValueText');

uicontrol('Parent',EditFrame_id, ...
	'Units','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[475 5 85 20], ...
	'HorizontalAlignment','left', ...
	'String','',...
	'Style','edit', ...
	'Tag','ValueEdit');

FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','plot_profile_cb(''save'')');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

hnd=[];
ViewMenu_id=uimenu('Label','&Widok','Tag','ViewMenu');

ViewScaleMenu_id=uimenu(ViewMenu_id,'Label','&Skala','Tag','ScaleSubmenu');
uimenu(ViewScaleMenu_id,'Label','Bez zmian','Check','on','CallBack','plot_profile_cb(''scale'')','Tag','0');
hnd(1)=uimenu(ViewScaleMenu_id,'Label','log2','Separator','on','CallBack','plot_profile_cb(''scale'')','Tag','2');
hnd(2)=uimenu(ViewScaleMenu_id,'Label','log10','CallBack','plot_profile_cb(''scale'')','Tag','10');
uimenu(ViewScaleMenu_id,'Label','exp2','Separator','on','CallBack','plot_profile_cb(''scale'')','Tag','-2');
uimenu(ViewScaleMenu_id,'Label','exp10','CallBack','plot_profile_cb(''scale'')','Tag','-10');

ViewNormMenu_id=uimenu(ViewMenu_id,'Label','&Centrowanie','Tag','NormSubmenu');
uimenu(ViewNormMenu_id,'Label','Brak','Check','on','CallBack','plot_profile_cb(''norm'')','Tag','nonorm');
uimenu(ViewNormMenu_id,'Label','rednia arytmetyczna','Separator','on','CallBack','plot_profile_cb(''norm'')','Tag','mean');
uimenu(ViewNormMenu_id,'Label','Mediana','CallBack','plot_profile_cb(''norm'')','Tag','median');
hnd(3)=uimenu(ViewNormMenu_id,'Label','rednia geometryczna','CallBack','plot_profile_cb(''norm'')','Tag','gmean');

ViewMeanMenu_id=uimenu(ViewMenu_id,'Label','&Typ wykresu','Tag','MeanSubmenu');
uimenu(ViewMeanMenu_id,'Label','Wartoci','Check','on','CallBack','plot_profile_cb(''plot_type'')','Tag','values');
uimenu(ViewMeanMenu_id,'Label','rednie + odchylenia','CallBack','plot_profile_cb(''plot_type'')','Tag','mean_std');
uimenu(ViewMeanMenu_id,'Label','rednie + odchylenia rednich','CallBack','plot_profile_cb(''plot_type'')','Tag','mean_mstd');
uimenu(ViewMeanMenu_id,'Label','Odporne rednie','Separator','on','CallBack','plot_profile_cb(''robust'')','Tag','robust_mean');
uimenu(ViewMeanMenu_id,'Label','Odporne odchylenia','CallBack','plot_profile_cb(''robust'')','Tag','robust_std');

TestMenu_id=uimenu('Label','&Informacje');
uimenu(TestMenu_id,'Label','&Boxplot','CallBack','plot_profile_cb(''boxplot'')');
hnd(4)=uimenu(TestMenu_id,'Label','&Testy istotnoci','Separator','on','CallBack','tst1D');

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
Array_id=findobj(0,'Tag','ArrayView');
aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
cnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');
color=ctable;

switch get(gcbf,'Tag')
	case 'ICA'
		data_type='ica';
		
		ica_data_struct=get(gcbf,'UserData');
		data=ica_data_struct.v;
		gene_nr=ica_data_struct.component_nr;
		profile=data(:,gene_nr);
		gene_name='';

	case {'SVD','Denoise'}
		data_type='svd';

		svd_data_struct=get(gcbf,'UserData');
		data=svd_data_struct.v;
		gene_nr=svd_data_struct.eigengene_nr;
		profile=data(:,gene_nr);
		gene_name='';

	otherwise
		data_type='gene';

		data=get(Array_id,'UserData');
		gene_nr=str2num(get(findobj(Array_id,'Tag','SelectedGeneEdit'),'String'));
		if isempty(gene_nr)
			close(PlotProfile_id);
			errordlg('Nie zostaa wybrana adna cecha','MStat');
			return;
		end;
		profile=data(gene_nr,:);
		gene_name=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'String');
end;

if ~isempty(find(profile<=0))
	for i=1:3
		set(hnd(i),'Enable','off');
	end;
end;
if max(aorder)==1
	set(hnd(4),'Enable','off');
end;

data_struct.data=profile;
data_struct.data_type=data_type;
data_struct.plot_type='values';
data_struct.robust_mean=0;
data_struct.robust_std=0;
data_struct.log_base=0;
data_struct.norm='nonorm';
data_struct.gene_nr=gene_nr;
data_struct.gene_name=gene_name;
data_struct.aorder=aorder;
data_struct.anames=anames;
data_struct.cnames=cnames;
data_struct.color=ctable;
data_struct.ylabel='Wzgldny poziom ekspresji';

switch data_struct.data_type
	case 'gene'
		title=['Profil ekspresji: ' data_struct.gene_name];
	case 'svd'
		title=['Profil ekspresji cechy wasnej nr.' num2str(data_struct.gene_nr)];
	case 'ica'
		title=['Profil ekspresji skadowej niezalenej nr.' num2str(data_struct.gene_nr)];
end;
set(PlotProfile_id,'UserData',data_struct,'Name',title);
plot_profile_cb('redraw',PlotProfile_id);

set(Array_id,'Pointer','arrow');
return;