function plot_profile_cb(action,fig);

if nargin==1
	PlotProfile_id=gcbf;
else
	PlotProfile_id=fig;
end;

Array_id=findobj(0,'Tag','ArrayView');
PlotAxes_id=findobj(PlotProfile_id,'Tag','PlotAxes');
ArrayNameEdit_id=findobj(PlotProfile_id,'Tag','ArrayNameEdit');
ArrayNameText_id=findobj(PlotProfile_id,'Tag','ArrayNameText');
ClassNameEdit_id=findobj(PlotProfile_id,'Tag','ClassNameEdit');
ClassNameText_id=findobj(PlotProfile_id,'Tag','ClassNameText');
ValueEdit_id=findobj(PlotProfile_id,'Tag','ValueEdit');
ValueText_id=findobj(PlotProfile_id,'Tag','ValueText');
Panel_id=findobj(PlotProfile_id,'Tag','EditPanel');
ScaleSubmenu_id=findobj(PlotProfile_id,'Tag','ScaleSubmenu');
NormSubmenu_id=findobj(PlotProfile_id,'Tag','NormSubmenu');
MeanSubmenu_id=findobj(PlotProfile_id,'Tag','MeanSubmenu');

switch action
	case 'save'
		data_struct=get(PlotProfile_id,'UserData');
		set(Panel_id,'Visible','off');
		figsave_cb(0,data_struct.gene_name);
		set(Panel_id,'Visible','on');

	case 'click'
		data_struct=get(PlotProfile_id,'UserData');
		
		data=data_struct.data;
		index=find(isnan(data)==0);
		
		switch data_struct.log_base
			case 2
				data(index)=log2(data(index));
			case 10
				data(index)=log10(data(index));
			case {-2,-10}
				data(index)=(-1*data_struct.log_base).^data(index);
		end;
		
		if strcmp(data_struct.plot_type,'values')==1
			array_nr=get(gcbo,'UserData');
			set(ArrayNameEdit_id,'String',data_struct.anames{array_nr});
			if max(data_struct.aorder)~=1
				set(ClassNameEdit_id,'String',data_struct.cnames{data_struct.aorder(array_nr)});
			else
				set(ClassNameEdit_id,'String','');
			end;
			set(ValueEdit_id,'String',num2str(data(array_nr)));

			if ~isempty(get(gcbf,'currentmodifier')) & strcmp(get(gcbf,'currentkey'),'shift')
				config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');
				config.view_struct.selected_array=array_nr;
				config.view_struct.selected_gene=max(config.view_struct.selected_gene,1);
				set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);
				mstat_cb('set_selected_array');
				axes(PlotAxes_id);
			end
		else
			class_nr=get(gcbo,'UserData');
			set(ClassNameEdit_id,'String',data_struct.cnames{class_nr});
			set(ArrayNameEdit_id,'String','');
			
			class_data=data(find(data_struct.aorder==class_nr));
			class_data=class_data(find(isnan(class_data)==0));
			
			if data_struct.robust_mean==0
				m=mean(class_data);
			else
				m=median(class_data);
			end;
			if data_struct.robust_std==0
				s=std(class_data);
			else
				s=rstd(class_data);
			end;
			if strcmp(data_struct.plot_type,'mean_mstd')==1
				s=s/sqrt(length(class_data));
			end;
			
			set(ValueEdit_id,'String',num2str(m));
		end;

	case 'robust'
		data_struct=get(PlotProfile_id,'UserData');

		selected=gcbo;
		if strcmp(get(selected,'Checked'),'off')
			set(selected,'Checked','on');
			value=1;
		else
			set(selected,'Checked','off');
			value=0;
		end;
		
		if strcmp(get(selected,'Tag'),'robust_mean')
			data_struct.robust_mean=value;
		else
			data_struct.robust_std=value;
		end;
		set(PlotProfile_id,'UserData',data_struct);
		plot_profile_cb('redraw');
			
	case 'scale'
		selected=gcbo;
		set(get(ScaleSubmenu_id,'Child'),'Check','off');
		set(selected,'Check','on');

		data_struct=get(PlotProfile_id,'UserData');
		log_base=str2num(get(selected,'Tag'));
		if log_base~=data_struct.log_base
			data_struct.log_base=log_base;
			set(PlotProfile_id,'UserData',data_struct);
			plot_profile_cb('redraw');
		end;
		
	case 'norm'
		selected=gcbo;
		set(get(NormSubmenu_id,'Child'),'Check','off');
		set(selected,'Check','on');

		data_struct=get(PlotProfile_id,'UserData');
		norm=get(selected,'Tag');
		if strcmp(data_struct.norm,norm)==0
			data_struct.norm=norm;
			set(PlotProfile_id,'UserData',data_struct);
			plot_profile_cb('redraw');
		end;

	case 'plot_type'
		selected=gcbo;
		hnd=get(MeanSubmenu_id,'Child');
		for i=1:length(hnd)
			if isempty(strfind(get(hnd(i),'Tag'),'robust'))
				set(hnd(i),'Check','off');
			end;
		end;
		set(selected,'Check','on');

		data_struct=get(PlotProfile_id,'UserData');
		plot_type=get(selected,'Tag');
		if strcmp(data_struct.plot_type,plot_type)==0
			data_struct.plot_type=plot_type;
			set(PlotProfile_id,'UserData',data_struct);
			plot_profile_cb('redraw');
		end;
		
	case 'boxplot'
		data_struct=get(PlotProfile_id,'UserData');
		plot_box(data_struct.data,data_struct.aorder,data_struct.cnames,data_struct.gene_name)

	case 'redraw'
		data_struct=get(PlotProfile_id,'UserData');
		data=data_struct.data;
		index=find(isnan(data)==0);
		
		switch data_struct.log_base
			case 2
				data(index)=log2(data(index));
			case 10
				data(index)=log10(data(index));
			case {-2,-10}
				data(index)=(-1*data_struct.log_base).^data(index);
		end;

		switch data_struct.norm
			case 'mean'
				data(index)=data(index)-mean(data(index));
			case 'median'
				data(index)=data(index)-median(data(index));
			case 'gmean'
				data(index)=data(index)-gmean(data(index));
		end;

		axes(PlotAxes_id);
		delete(findobj(gca,'Type','patch'));
		delete(findobj(gca,'Type','line'));
		hold on;
		if strcmp(data_struct.plot_type,'values')==1
			for i=1:length(data)
				cindex=mod(data_struct.aorder(i),length(data_struct.color));
				if cindex==0
					cindex=length(data_struct.color);
				end;

				h=fill([i-0.5;i-0.5;i+0.5;i+0.5],[0;data(i);data(i);0],data_struct.color(cindex,:));
				set(h,'ButtonDownFcn','plot_profile_cb(''click'')','UserData',i);
			end;
			set(PlotAxes_id,'XLim',[0.5 length(data)+0.5],'XTick',[],'box','on','FontName','Arial CE','FontSize',9);
		else
			classes=unique(data_struct.aorder);
			for i=1:length(classes)
				cindex=mod(classes(i),length(data_struct.color));
				if cindex==0
					cindex=length(data_struct.color);
				end;
				index=find(data_struct.aorder==classes(i));
				if ~isempty(index)
					class_data=data(index);
					class_data=class_data(find(isnan(class_data)==0));
					if data_struct.robust_mean==0
						m=mean(class_data);
					else
						m=median(class_data);
					end;
					if data_struct.robust_std==0
						s=std(class_data);
					else
						s=rstd(class_data);
					end;
					if strcmp(data_struct.plot_type,'mean_mstd')==1
						s=s/sqrt(length(class_data));
					end;
					
					h=fill([i-0.40;i-0.40;i+0.40;i+0.40],[0;m;m;0],data_struct.color(cindex,:));
					set(h,'ButtonDownFcn','plot_profile_cb(''click'')','UserData',i);
					
					h=line([i i],[m-s m+s]);
					set(h,'Color',[0 0 0],'LineWidth',1.0);
					h=line([i-0.1 i+0.1],[m-s m-s]);
					set(h,'Color',[0 0 0],'LineWidth',1.0);
					h=line([i-0.1 i+0.1],[m+s m+s]);
					set(h,'Color',[0 0 0],'LineWidth',1.0);
				end;
			end;
			set(PlotAxes_id,'XLim',[0.5 length(classes)+0.5],'XTick',[],'box','on','FontName','Arial CE','FontSize',9);
		end;
		h=line(get(PlotAxes_id,'XLim'),[0 0]);
		set(h,'Color',[0 0 0]);
		hold off;
		ylabel(data_struct.ylabel);
end;