function plot_profiles;

size_x=620;
size_y=490;

screen_size=get(0,'screensize');
screen_width=screen_size(3); 
screen_height=screen_size(4);

pos_x=(screen_width-size_x)/2;
pos_y=(screen_height-size_y)/2;

PlotProfiles_id=figure('Units','pixels',...
			'Visible','on',...
			'Color',get(0,'defaultUicontrolBackgroundColor'),...
			'NumberTitle','off',...
			'MenuBar','none',...
			'Resize','on',...
			'ResizeFcn','plot_pca_cb(''resize'')',...			
			'KeyPressFcn',@figure_kb_cb,...	
			'Tag','PlotProfiles');

PlotAxes_id=axes('Parent',PlotProfiles_id,...
		'Units','pixels',...
		'box','on',...
		'FontSize',8,...
		'Position',[35 100 560 400],...
		'Tag','PlotAxes');
		
FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','figsave_cb');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

ViewMenu_id=uimenu('Label','&Widok','Tag','ViewMenu');
ViewMeanMenu_id=uimenu(ViewMenu_id,'Label','rednia','Tag','ViewMeanSubmenu');
uimenu(ViewMeanMenu_id,'Label','&Arytmetyczna','Checked','on','CallBack','plot_profiles_cb(''mean'')','Tag','mean');
uimenu(ViewMeanMenu_id,'Label','&Geometryczna','CallBack','plot_profiles_cb(''mean'')','Tag','gmean');
uimenu(ViewMeanMenu_id,'Label','&Mediana','CallBack','plot_profiles_cb(''mean'')','Tag','median');
uimenu(ViewMeanMenu_id,'Label','&RRollup','Separator','on','CallBack','plot_profiles_cb(''mean'')','Tag','rrollup');
uimenu(ViewMenu_id,'Label','&Skalowanie','Tag','Norm','Separator','on','CallBack','plot_profiles_cb(''scaling'')');


%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Array_id=findobj(0,'Tag','ArrayView');
data=get(Array_id,'UserData');
gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
group_nr=get(findobj(Array_id,'Tag','GeneClassPop'),'Value');
group_names=get(findobj(Array_id,'Tag','GeneClassPop'),'String');

index=find(gorder==group_nr);

%TODO pytanie o skale danych
data_struct=struct('data',data(index,:),'plot_mean',1,'mean_method','mean','scaling',0,'log_base',10);

if size(group_names,1)==1
	set(PlotProfiles_id,'UserData',data_struct,'Name','Profile ekspresji wszystkich cech');
else
	set(PlotProfiles_id,'UserData',data_struct,'Name',['Profile ekspresji cech grupy: ' group_names{group_nr}]);
end;

if min(min(data(index,:)))<0
	set(findobj(ViewMeanMenu_id,'Label','&Geometryczna'),'Enable','off')
end;

plot_profiles_cb('redraw',PlotProfiles_id);

