function plot_pval_cb(action);

PlotPVal_id=gcbf;
Array_id=findobj(0,'Tag','ArrayView');
SortMenu_id=findobj(findobj(PlotPVal_id,'Tag','Test'),'Tag','Sort');

switch action
	case 'sort'
		switch get(SortMenu_id,'Checked')
			case 'on'
				set(SortMenu_id,'Checked','off');
			case 'off'
				set(SortMenu_id,'Checked','on');
		end;
		plot_pval_cb('redraw');

	case 'anova_p'
		set(gcbf,'Pointer','watch');
		set(Array_id,'Pointer','watch');
		pause(0.01);

		data_struct=get(PlotPVal_id,'UserData');
		[F,t,p]=anova_test(data_struct{1},data_struct{2});
		[data_struct{3} data_struct{4}]=sort(p);
		set(gca,'XLim',[1 size(data_struct{1},1)]);
		ylabel('p-value (ANOVA)');

		set(gcbf,'Pointer','arrow');
		set(Array_id,'Pointer','arrow');

		set(PlotPVal_id,'UserData',data_struct);
		plot_pval_cb('redraw');

	case 'anova_t'
		set(gcbf,'Pointer','watch');
		set(Array_id,'Pointer','watch');
		pause(0.01);

		data_struct=get(PlotPVal_id,'UserData');
		[F,t]=anova_test(data_struct{1},data_struct{2});
		[t,index]=sort(t);
		data_struct{3}=t(end:-1:1);
		data_struct{4}=index(end:-1:1);
		set(gca,'XLim',[1 size(data_struct{1},1)]);
		ylabel('T^2 (ANOVA)');

		set(gcbf,'Pointer','arrow');
		set(Array_id,'Pointer','arrow');

		set(PlotPVal_id,'UserData',data_struct);
		plot_pval_cb('redraw');

	case 'kw'
		set(gcbf,'Pointer','watch');
		set(Array_id,'Pointer','watch');
		pause(0.01);

		data_struct=get(PlotPVal_id,'UserData');
		p=kw(data_struct{1},data_struct{2});
		[data_struct{3} data_struct{4}]=sort(p);
		set(gca,'XLim',[1 size(data_struct{1},1)]);
		ylabel('p-value (Kruskal-Wallis)');

		set(gcbf,'Pointer','arrow');
		set(Array_id,'Pointer','arrow');

		set(PlotPVal_id,'UserData',data_struct);
		plot_pval_cb('redraw');

	case 'satterthwaite'
		set(gcbf,'Pointer','watch');
		set(Array_id,'Pointer','watch');
		pause(0.01);

		data_struct=get(PlotPVal_id,'UserData');
		[d,p]=satterthwaite(data_struct{1},data_struct{2});
		[data_struct{3} data_struct{4}]=sort(p);
		set(gca,'XLim',[1 size(data_struct{1},1)]);
		ylabel('p-value (Satterthwaite)');
		set(Array_id,'Pointer','arrow');

		set(PlotPVal_id,'UserData',data_struct);
		plot_pval_cb('redraw');

	case 'mann-whitney'
		set(gcbf,'Pointer','watch');
		set(Array_id,'Pointer','watch');
		pause(0.01);

		data_struct=get(PlotPVal_id,'UserData');
		[w,p]=mann_whitney(data_struct{1},data_struct{2});
		[data_struct{3} data_struct{4}]=sort(p);
		set(gca,'XLim',[1 size(data_struct{1},1)]);
		ylabel('p-value (Mann-Whitney)');

		set(gcbf,'Pointer','arrow');
		set(Array_id,'Pointer','arrow');

		set(PlotPVal_id,'UserData',data_struct);
		plot_pval_cb('redraw');

	case 'histogram'
		data_struct=get(PlotPVal_id,'UserData');
		PlotPValHist_id=figure('Units','pixels',...
			'Visible','on',...
			'Name','Histogram p-value',...
			'Color',get(0,'defaultUicontrolBackgroundColor'),...
			'NumberTitle','off',...
			'MenuBar','none',...
			'Resize','off',...
			'Tag','PlotPValHist');

		FileMenu_id=uimenu('Label','&Plik');
		uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','figsave_cb');
		uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

		hist(data_struct{3},100);

	case 'redraw'
		data_struct=get(PlotPVal_id,'UserData');
		switch get(SortMenu_id,'Checked')
			case 'on'
				set(findobj(gca,'Type','Line'),'YData',data_struct{3});
			case 'off'
				set(findobj(gca,'Type','Line'),'YData',data_struct{3}(data_struct{4}));
		end;
		drawnow;
end;