function plot_sammon

size_x=620;
size_y=490;

screen_size=get(0,'screensize');
screen_width=screen_size(3); 
screen_height=screen_size(4);

pos_x=(screen_width-size_x)/2;
pos_y=(screen_height-size_y)/2;

PlotSammon_id=figure('Units','pixels', ...
		'Visible','on',...
		'MenuBar','none', ...
		'Color',get(0,'defaultUicontrolBackgroundColor'),...
		'NumberTitle','off', ...
		'Position',[pos_x pos_y size_x size_y],...
		'Name','Sammon plot',...
		'DeleteFcn','plot_sammon_cb(''exit'')',...
		'ResizeFcn','plot_sammon_cb(''resize'')',...
		'KeyPressFcn',@figure_kb_cb,...		
		'Tag','PlotSammon');

PlotAxes_id=axes('Parent',PlotSammon_id,...
		'Units','pixels',...
		'box','on',...
		'FontSize',8,...
		'Position',[55 50 560 400],...
		'Tag','PlotAxes');

FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','plot_sammon_cb(''save'')');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

%ViewMenu_id=uimenu('Label','&Widok');
%AxisSubmenu_id=uimenu(ViewMenu_id,'Label','&Osie','Tag','AxisSubmenu');
%uimenu(AxisSubmenu_id,'Label','Pokazuj &osie','Checked','on','CallBack','plot_sammon_cb(''plot_axes'')');
%uimenu(AxisSubmenu_id,'Label','Obr w poziomie','Separator','on','CallBack','plot_sammon_cb(''flip_horizontal'')');
%uimenu(AxisSubmenu_id,'Label','Obr w pionie','CallBack','plot_sammon_cb(''flip_vertical'')');
%MeanSubmenu_id=uimenu(ViewMenu_id,'Label','&rednie','Tag','MeanSubmenu');
%uimenu(MeanSubmenu_id,'Label','&rednie arytm.','CallBack','plot_sammon_cb(''plot_means'')','UserData',0);
%uimenu(MeanSubmenu_id,'Label','Mediany','CallBack','plot_sammon_cb(''plot_means'')','UserData',1);
%LegendSubmenu_id=uimenu(ViewMenu_id,'Label','&Opis','Tag','LegendSubmenu');
%uimenu(LegendSubmenu_id,'Label','Na grze po prawej','Checked','on','CallBack','plot_sammon_cb(''plot_legend'')','Tag','NorthEast');
%uimenu(LegendSubmenu_id,'Label','Na grze po lewej','Checked','off','CallBack','plot_sammon_cb(''plot_legend'')','Tag','NorthWest');
%uimenu(LegendSubmenu_id,'Label','Na dole po prawej','Checked','off','CallBack','plot_sammon_cb(''plot_legend'')','Tag','SouthEast');
%uimenu(LegendSubmenu_id,'Label','Na dole po lewej','Checked','off','CallBack','plot_sammon_cb(''plot_legend'')','Tag','SouthWest');
%uimenu(LegendSubmenu_id,'Label','Na zewntrz','Checked','off','CallBack','plot_sammon_cb(''plot_legend'')','Tag','NorthEastOutside');
%MarkerSubmenu_id=uimenu(ViewMenu_id,'Label','&Znaczniki','Tag','MarkerSubmenu');
%uimenu(MarkerSubmenu_id,'Label','&Symbole','Checked','off','CallBack','plot_sammon_cb(''plot_symbols'')');
%uimenu(MarkerSubmenu_id,'Label','&Etykiety','CallBack','plot_sammon_cb(''plot_labels'')');
%uimenu(MarkerSubmenu_id,'Label','&Due','Checked','off','CallBack','plot_sammon_cb(''plot_big'')');
%uimenu(MarkerSubmenu_id,'Label','&Wybieralne','Separator','on','Checked','on','CallBack','plot_sammon_cb(''marker_clickable'')');
%LanguageSubmenu_id=uimenu(ViewMenu_id,'Label','&Jzyk','Separator','on','Tag','LanguageSubmenu');
%uimenu(LanguageSubmenu_id,'Label','&Polski (liczby)','Checked','on','CallBack','plot_sammon_cb(''lang'')','UserData','pol_num');
%uimenu(LanguageSubmenu_id,'Label','P&olski','CallBack','plot_sammon_cb(''lang'')','UserData','pol');
%uimenu(LanguageSubmenu_id,'Label','&Angielski (liczby)','Separator','on','CallBack','plot_sammon_cb(''lang'')','UserData','eng_num');
%uimenu(LanguageSubmenu_id,'Label','A&ngielski','CallBack','plot_sammon_cb(''lang'')','UserData','eng');


Array_id=findobj(0,'Tag','ArrayView');
set(Array_id,'Pointer','watch');
set(PlotSammon_id,'Pointer','watch');
pause(0.01);

data=get(Array_id,'UserData');
opts.Display        = 'off';	%Display  - {'off', 'on', 'iter'}
opts.Input          = 'raw';	%{'raw','distance'} if set to 'distance', X is interpreted as a matrix of pairwise distances.
opts.MaxHalves      = 20;	%maximum number of step halvings
opts.MaxIter        = 500;	%maximum number of iterations
opts.TolFun         = 1e-9;	%relative tolerance on objective function
opts.Initialisation = 'random';	%{'pca', 'random'}

data_struct.sammon_data=sammon(data',2,opts)';

data_struct.order=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
data_struct.names=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
data_struct.cnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');
data_struct.color=ctable;
data_struct.selected=[];
data_struct.color=ctable;
data_struct.mean_symbol='o';
data_struct.plot_symbols=0;
data_struct.symbols={'o';'x';'s';'^';'v';'d';'p';'h';'<';'>';'*'};
data_struct.symbols_sizes=[2;5;5;5;5;5;5;5;5;5;5];
data_struct.symbols_big=0;
data_struct.plot_axes=1;
data_struct.plot_labels=0;
data_struct.marker_clickable=1;
if length(data_struct.cnames)==1
	data_struct.plot_legend=0;
%	set(LegendSubmenu_id,'Enable','off');
%	set(get(LegendSubmenu_id,'Child'),'Checked','off');
else
	data_struct.plot_legend=1;
%	set(LegendSubmenu_id,'Enable','on');
end;
data_struct.legend_position='NorthEast';

set(PlotSammon_id,'UserData',data_struct);
plot_sammon_cb('redraw',PlotSammon_id);

set(Array_id,'Pointer','arrow');
set(PlotSammon_id,'Pointer','arrow');
return;