function [T,lambda,m,X_pca]=pca(X,pc_count,method);

if nargin<1
	error('Brak danych wejciowych');
elseif nargin<2
	pc_count=-1;
	method='svd';
elseif nargin<3
	method='svd';
end;

features_count=size(X,1);			%wymiar wektorow cech
vectors_count=size(X,2);			%liczba wektorow cech

if pc_count<1 || pc_count>size(X,2)-1
	pc_count=min(features_count,vectors_count-1);
end;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Usunicie wektora wartoci rednich danych%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
m=mean(X,2);
X=X-repmat(m,1,size(X,2));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Wyznaczenie macierzy transformacji%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
switch lower(method)
	case 'cov'
		[evect,evals]=eig(cov(X',1));
		[evals,index]=sort(diag(evals),'descend');
		evect=evect(:,index);

		%r=min(size(X,1),size(X,2)-1);
		r=sum(evals>max(size(X))*eps(max(evals)));
		pc_count=min(r,pc_count);

		T=evect(:,1:pc_count);
		lambda=evals(1:pc_count);

	case 'svd'
		[u,s,v]=svd(X,0);

		%r=min(size(X,1),size(X,2)-1);
		s=diag(s);
		r=sum(s>max(size(X))*eps(max(s)));
		pc_count=min(r,pc_count);

		T=u(:,1:pc_count);
		lambda=(s(1:pc_count).^2)/(vectors_count-1);

	case 'mor'
		for l=1:pc_count
			max_dist=0;
			for i=1:vectors_count
				dist=X(:,i)'*X(:,i);
				if dist>max_dist
					max_dist=dist;
					max_index=i;
				end;
			end;
	
			T(:,l)=X(:,max_index)/sqrt(max_dist);
			eta=2*max_dist;
			for k=1:ceil(500/vectors_count)
				for j=1:vectors_count
					y=T(:,l)'*X(:,j);
					eta=eta+y^2;
					T(:,l)=T(:,l)+(y/eta)*(X(:,j)-y*T(:,l));
				end;
			end;
			eta
			if pc_count~=1
				for j=1:vectors_count
					X(:,j)=X(:,j)-T(:,l)'*X(:,j)*T(:,l);;
				end;
			end;
		end;
		T=-1*T;
end;

if nargout>3
	X_pca=T'*X;
end;