function s=rstd(x,sigma_est)

if nargin==1
	sigma_est='mad';
end;

nan_index=isnan(x);
x=x(find(nan_index==0));

if (~isempty(x))
	switch sigma_est
		case 'std'
			s=std(x);
		case 'iqr'
			s=iqr(x)/1.349;
		case 'mad'
			s=maad(x)/0.6745;
	end;
else
	s=NaN;
end;

%
%%%%%%%%%%%%%%%%%%%%%
function m=maad(x,med)

if nargin==1
	med=1;
end;

nan_index=isnan(x);
x=x(find(nan_index==0));

if (~isempty(x))
	if med==1
		m=median(abs(x-median(x)));
	else
		m=mean(abs(x-mean(x)));
	end;
else
	m=NaN;
end;