function [white_data,t,inv_t,u]=whitening(data,method)
%t - whiteing matrix
%inv_t - dewhiteing matrix
%u - rotation matrix

if nargin==1
	method='svd';
end;

vectors_count=size(data,2);
dimension=size(data,1);

data=data-repmat(mean(data,2),1,vectors_count);

tolerance=1e-7;
switch method
	case 'cov'
		[e,d]=eig(cov(data',1));

		[d,index]=sort(diag(d));
		d=diag(abs(d(end:-1:1)'));
		e=e(:,index(end:-1:1));

		eigen_count=sum(diag(d)>tolerance)

		d=d(1:eigen_count,1:eigen_count);
		e=e(:,1:eigen_count);

		sqrt_d=sqrt(d);

		t=inv(sqrt_d)*e';
		inv_t=e*sqrt_d;

	case 'svd'
		[u,s,v]=svd(data,'econ');

		eigen_count=sum(diag(s)>tolerance)

		s=s(1:eigen_count,1:eigen_count);
		u=u(:,1:eigen_count);

		sqrt_s=s/sqrt(vectors_count);

%		inv_sqrt_s=1./diag(sqrt_s);
%		inv_sqrt_s=diag(inv_sqrt_s);
%		t=inv_sqrt_s*u';
		
		t=inv(sqrt_s)*u';
		inv_t=u*sqrt_s;
end;
white_data=t*data;


