function table_cb(table,action,param)

if (nargin==2)
	param=[];
end;

table_model=table.getModel;
row_count=table.getRowCount;
column_count=table.getColumnCount;

Array_id=findobj(0,'Tag','ArrayView');
config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

switch action
		case 'Zapisz'
			[name,path,format]=uiputfile({'*.tsv','Pliki TSV (*.tsv)';'*.*','Wszystkie pliki (*.*)'},'Zapisz do pliku',[config.export_path param '.tsv']);
			if isequal(name,0) || isequal(path,0)
				return;
			else
				[filename,format]=getfname(name,path,format,{'tsv'});
			
				fid=fopen(filename,'w');
				if fid==-1 
					beep;
					%set(Array_id,'Pointer','arrow');
					worndlg('Bd podczas zapisu pliku','MStat');
					return;
				end;
				
				line='';
				for i=1:column_count
					if i==1
						line=sprintf('%s',table.getColumnName(i-1).toCharArray());
					else
						line=sprintf('%s\t%s',line,table.getColumnName(i-1).toCharArray());
					end;
				end;
				fprintf(fid,'%s\n',line);
				
				for i=1:row_count
					line='';
					for j=1:column_count
						if j==1
							line=sprintf('%s',table_model.getValueAt(i-1,j-1));
						else
							line=sprintf('%s\t%s',line,table_model.getValueAt(i-1,j-1));
						end;
					end;
					fprintf(fid,'%s\n',line);
				end;
				fclose(fid);
				
				if ~isempty(path) && ~isequal(path,0)
					config.export_path=path;
					set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);
				end;
			end;
			
		case 'Szukaj'
			gnames=cell(row_count-1,1);
			dnames=cell(row_count-1,1);
			for i=1:row_count
				gnames{i}=table_model.getValueAt(i-1,1);
				dnames{i}=table_model.getValueAt(i-1,2);
			end;

			selected=table.getSelectedRow+1;
			if selected>0
				selected=selected+1;
			else
				selected=1;
			end;

			str=strtrim(char(param.getText));

			if ~isempty(str)
				index=find_str(str,gnames,selected,length(gnames),0);
				if index<=0 && index~=1
					index=find_str(str,dnames,selected,length(dnames),0);
					if index<=0 && index~=1
						selected_option=questdlg('Czy szuka od pocztku zbioru?','MStat','Tak','Nie','Tak');
						pause(0.1); 
						if strcmp(selected_option,'Tak')
							index=find_str(str,gnames,1,selected,0);
							if index<=0 && index~=1
								index=find_str(str,dnames,1,selected,0);
							end;
						end;
					end;
				end;
			end;

			if index>0
				table.changeSelection(index-1,0,false,false);
				table.repaint;
			end;
	end;