function figsave_cb(axes_only,name,imsize);

format_str={'png';'bmp';'jpg';'tiff';'eps';'svg'};
ext_str={'png';'bmp';'jpg';'tif';'eps';'svg'};

if nargin==0
	axes_only=0;
	name=['noname.' format_str{1}];
	imsize=[];
end;
if nargin==1
	name=['noname.' format_str{1}];
	imsize=[];
end;
if nargin==2
	imsize=[];
end;
if nargin==2
	imsize=[];
end;

Fig_id=gcbf;

Array_id=findobj(0,'Tag','ArrayView');
if ~isempty(Array_id)
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');
else
	config.export_path='.';
end;

[name,path,format]=uiputfile({'*.png','Plik PNG (*.png)';'*.bmp','Plik BMP (*.bmp)';'*.jpg','Plik JPEG (*.jpg)';'*.tif','Plik TIFF (*.tif)';'*.eps','Plik EPS (*.eps)';'*.svg','Plik SVG (*.svg)';'*.*','Wszystkie pliki (*.*)'},'Zapisz obraz do pliku',[config.export_path name]);
if isequal(name,0) || isequal(path,0)
	return;
else

	[filename,format]=getfname(name,path,format,ext_str);
	
	if axes_only==1
		fig=getframe(gca);
	else
		current_color=get(Fig_id,'Color');
		set(Fig_id,'Color',[1 1 1]);
		fig=getframe(Fig_id);
		set(Fig_id,'Color',current_color);
	end;

	if ~isempty(imsize) & size(fig.cdata,1)>=imsize(1) & size(fig.cdata,2)>=imsize(2)
		image_data=fig.cdata(1:imsize(1),1:imsize(2),:);
	else
		image_data=fig.cdata;
	end;

	switch format
		case 3
			imwrite(image_data,filename,'jpeg','Quality',100);
		case 5
			set(Fig_id,'PaperPositionMode','auto')
			print(Fig_id,'-depsc2','-r600',filename);
		case 6
			plot2svg(filename,Fig_id)
		otherwise 
	%		[image,cmap]=rgb2ind(fig.cdata,256);
	%		imwrite(image,cmap,filename,format_str{format});
			imwrite(image_data,filename,format_str{format});
	end;

	if ~isempty(Array_id) & ~isempty(path) & path~=0
		config.export_path=path;
		set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);
	end;
end;