function [out_str,exact_match,to_parentesis,search_back]=finddlg(title,str,exact,parentesis)

if nargin==0
	str='';
	title='Szukaj';
	exact=0;
	parentesis=0;
elseif nargin==1
	str='';
	exact=0;
	parentesis=0;
elseif nargin==2
	exact=0;
	parentesis=0;
elseif nargin==3
	parentesis=0;
end;

size_x=305;
size_y=115;

Array_id=findobj(0,'Tag','ArrayView');
config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

%FigPos= get(0,'DefaultFigurePosition');
%FigPos(3)=300;
%FigPos(4)=110;
		
FindDlg_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Visible','on',...
		'Color',get(0,'defaultUicontrolBackgroundColor'),...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name',title, ...
		'UserData',0,...
		'KeyPressFcn',@finddlg_kb_cb,...
		'Tag','FindDlg');

FindEdit_id=uicontrol('Parent',FindDlg_id, ...
	'Style','Edit',...
	'Units','pixels',...
	'BackgroundColor',[1 1 1], ...
	'HorizontalAlignment','left', ...
	'Position',[10 95 290 20],...
	'String',char(str),...
	'Tag','FindEdit',...
	'KeyPressFcn',@finddlg_kb_cb);

ExactCheck_id=uicontrol('Parent',FindDlg_id, ...
	'Units','pixels', ...
	'Position',[10 75 240 18], ...
	'String','Tylko dokadne dopasowanie',...
	'Style','checkbox', ...
	'Value',exact,...
	'Tag','ExactMatchCheck',...
	'Callback','');

ParentesisCheck_id=uicontrol('Parent',FindDlg_id, ...
	'Units','pixels', ...
	'Position',[10 55 240 18], ...
	'String','Tylko cz nazwy do nawiasu',...
	'Style','checkbox', ...
	'Value',parentesis,...
	'Tag','ParentesisCheck',...
	'Callback','');

BackCheck_id=uicontrol('Parent',FindDlg_id, ...
	'Units','pixels', ...
	'Position',[10 35 240 18], ...
	'String','Szukanie wstecz',...
	'Style','checkbox', ...
	'Value',0,...
	'Tag','ParentesisCheck',...
	'Callback','');

uicontrol('Parent',FindDlg_id,...
	'Style','PushButton',...
	'Units','pixels',...
	'Position',[135 5 80 20],...
	'String','Szukaj',...
	'CallBack',@ok_cb);

uicontrol('Parent',FindDlg_id,...
	'Style','PushButton',...
	'Units','pixels',...
	'Position',[220 5 80 20],...
	'String','Zamknij',...
	'CallBack',@cancel_cb);

uicontrol(FindEdit_id);
uiwait(FindDlg_id);

out_str=[];
exact_match=0;
to_parentesis=0;
search_back=0;
if ishandle(FindDlg_id)
	if get(FindDlg_id,'UserData')~=0
		out_str=get(FindEdit_id,'String');
		if length(out_str)>0
			exact_match=get(ExactCheck_id,'Value');
			to_parentesis=get(ParentesisCheck_id,'Value');
			search_back=get(BackCheck_id,'Value');
		end;
	end;
	close(FindDlg_id)
end;

return;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function cancel_cb(hnd,event_data)
set(gcbf,'UserData',0);
uiresume(gcbf);
return;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function ok_cb(hnd,event_data)
set(gcbf,'UserData',1);
uiresume(gcbf);
return;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function finddlg_kb_cb(src,event)

if strcmp(event.Key,'return')==1
	pause(0.1);
	ok_cb(src,[]);
elseif strcmp(event.Key,'escape')==1
	pause(0.1);
	cancel_cb(src,[]);
end;

