/* absolute_rank_selection.h: defintions and prototypes for functions
 * to compute a normalising function based on absolute rank selection
 * invariant sets.
 */

#ifndef _ABSOLUTE_RANK_SELECTION_H
#define _ABSOLUTE_RANK_SELECTION_H

/* Type definitions for functions required as arguments for
 * iterated_global_normalisation.
 */
typedef void *(*_ARS_newfunction)(int, double *, double *);

typedef struct {
  int index;
  double value;
} _ARS_idpair;
typedef struct {
  int index;
  int value;
} _ARS_iipair;

void **absolute_rank_selection_all(int n, double *x, double *y,
				   _ARS_newfunction new_function);
void *absolute_rank_selection(int n, double *x, double *y, int t,
			      _ARS_newfunction new_function);

#endif
