/* iterated_global_normalisation.h: definitions and prototype for
 * function implemented in iterated_global_normalisation.c.
 */

#ifndef _ITERATED_GLOBAL_NORMALISATION_H
#define _ITERATED_GLOBAL_NORMALISATION_H
/* _IGN_MAXITERATIONS is the maximum number of updates of the
 * normalising function, _IGN_SLOPE is the number of standard
 * deviations a point has to be from the current normalising function
 * for the weight of the point to be 1/2.
 */
#define _ITERATED_GLOBAL_NORMALISATION_MAXITERATIONS 100
#define _ITERATED_GLOBAL_NORMALISATION_SLOPE 1

/* Type definitions for functions required as arguments for
 * iterated_global_normalisation.
 */
typedef void *(*_IGN_newfunction)(int, double *, double *, double *);
typedef double (*_IGN_evalfunction)(void *, double);
typedef int (*_IGN_cmpfunction)(void *, void *);
typedef void (*_IGN_freefunction)(void *);
typedef double (*_IGN_weight)(double, double, double, double);

void *iterated_global_normalisation
(int n, double *x, double *y, _IGN_newfunction new_function,
 _IGN_evalfunction eval_function, _IGN_cmpfunction cmp_functions,
 _IGN_freefunction free_function, _IGN_weight weight);
#endif
