/* relative_rank_selection.h: defintions and prototypes for functions
 * to compute a normalising function based on relative rank selection
 * invariant sets.
 */

#ifndef _RELATIVE_RANK_SELECTION_H
#define _RELATIVE_RANK_SELECTION_H

/* Type definitions for functions required as arguments for
 * iterated_global_normalisation.
 */
typedef void *(*_RRS_newfunction)(int, double *, double *);

typedef struct {
  int index;
  double value;
} _RRS_idpair;
typedef struct {
  int index;
  int value;
} _RRS_iipair;

void **relative_rank_selection_all(int n, double *x, double *y,
				   _RRS_newfunction new_function);
void *relative_rank_selection(int n, double *x, double *y, int t,
			      _RRS_newfunction new_function);

#endif
