function filter_genes;

size_x=292;
size_y=325;

Array_id=findobj(0,'Tag','ArrayView');
config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

data=get(Array_id,'UserData');

dimension=size(data,1);
vectors_nr=size(data,2);
max_val=max(data(:));
min_val=min(data(:));
m=mean(data,2);

missing_info=get(findobj(Array_id,'Tag','ValueEdit'),'UserData');
if missing_info(1)==0
	enable='on';
else
	enable='off';
end;

if length(find(m==0))==dimension
	mstd_enable='off';
else
	mstd_enable='on';
end;

Filter_id=findobj('Tag','Filter');
if isempty(Filter_id)==0
	figure(Filter_id);
else
	Filter_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','Filtracja cech', ...
		'KeyPressFcn',@figure_kb_cb,...
		'Tag','FilterGenes');

	hnd=uipanel('Parent',Filter_id, ...
		'Title','Parametry:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 285 290], ...
		'Tag','FilterPanel');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 253 70 18], ...
		'String','Wicej ni',...
		'Style','radio', ...
		'Enable',enable,...
		'Value',(missing_info(1)==0),...
		'Tag','SameNrRadio',...
		'Callback','filter_genes_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[80 255 50 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(vectors_nr-round(0.2*vectors_nr)),...
		'Style','edit', ...
		'Enable',enable,...
		'Tag','SameNrEdit',...
		'UserData',[1 vectors_nr vectors_nr-round(0.2*vectors_nr) 2],...
		'Callback','filter_genes_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[140 253 120 18], ...
		'HorizontalAlignment','left', ...
		'String','takich samych wartoci', ...
		'Enable',enable,...
		'Style','text', ...
		'Tag','SameNrEditText');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 230 70 18], ...
		'String','Wicej ni',...
		'Style','radio', ...
		'Enable',enable,...
		'Tag','CommonNrRadio',...
		'Callback','filter_genes_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[80 230 50 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(vectors_nr-round(0.2*vectors_nr)),...
		'Style','edit', ...
		'Enable','off',...
		'Tag','CommonNrEdit',...
		'UserData',[1 vectors_nr vectors_nr-round(0.2*vectors_nr) 2],...
		'Callback','filter_genes_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[140 228 120 18], ...
		'HorizontalAlignment','left', ...
		'String','wartoci wsplnych', ...
		'Enable',enable,...
		'Style','text', ...
		'Tag','CommonNrEditText');

%
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 205 70 18], ...
		'String','Mniej ni',...
		'Enable',enable,...
		'Style','radio', ...
		'Tag','MaxRadio',...
		'Callback','filter_genes_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[80 205 50 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(floor(0.1*vectors_nr)),...
		'Style','edit', ...
		'Enable','off',...
		'Tag','MaxEdit1',...
		'UserData',[1 vectors_nr floor(0.1*vectors_nr) 2],...
		'Callback','filter_genes_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[140 203 120 18], ...
		'HorizontalAlignment','left', ...
		'String','wartoci >', ...
		'Enable',enable,...
		'Style','text', ...
		'Tag','MaxEditText');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[225 205 50 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(min_val),...
		'Style','edit', ...
		'Tag','MaxEdit2',...
		'Enable','off',...
		'UserData',[min_val max_val min_val 1],...
		'Callback','filter_genes_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 180 70 18], ...
		'String','Mniej ni',...
		'Enable',enable,...
		'Style','radio', ...
		'Tag','MedianRatioRadio',...
		'Callback','filter_genes_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[80 180 50 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(floor(0.05*vectors_nr)),...
		'Style','edit', ...
		'Enable','off',...
		'Tag','MedianRatioEdit1',...
		'UserData',[1 vectors_nr floor(0.1*vectors_nr) 2],...
		'Callback','filter_genes_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[140 178 120 18], ...
		'HorizontalAlignment','left', ...
		'String','wartoci > MED *', ...
		'Enable',enable,...
		'Style','text', ...
		'Tag','MedianRatioEditText');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[225 180 50 20], ...
		'HorizontalAlignment','right', ...
		'String','1.5',...
		'Style','edit', ...
		'Tag','MedianRatioEdit2',...
		'Enable','off',...
		'UserData',[1 inf 1.5 1],...
		'Callback','filter_genes_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 155 70 18], ...
		'String','IQR <',...
		'Style','radio', ...
		'Value',0,...
		'Enable',enable,...
		'Tag','IQRRadio',...
		'Callback','filter_genes_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[80 155 50 20], ...
		'HorizontalAlignment','right', ...
		'String','0.3',...
		'Style','edit',...
		'Enable','off',...
		'Tag','IQREdit',...
		'UserData',[0 inf 0.3 1],...
		'Callback','filter_genes_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'Position',[140 155 135 20], ...
		'Enable',enable,...
		'String','Posortowane IQR', ...
		'Tag','IQRButt', ...
		'CallBack','plot_iqr');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 130 70 18], ...
		'String','CV <',...
		'Style','radio', ...
		'Enable',enable,...
		'Value',0,...
		'Tag','StdRadio',...
		'Callback','filter_genes_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[80 130 50 20], ...
		'HorizontalAlignment','right', ...
		'String','0.3',...
		'Style','edit',...
		'Enable','off',...
		'Tag','StdEdit',...
		'UserData',[0 inf 0.3 1],...
		'Callback','filter_genes_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'Position',[140 130 135 20], ...
		'String','Posortowane CV', ...
		'Enable',enable,...
		'Tag','StdButt', ...
		'CallBack','plot_sd');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 105 75 18], ...
		'String','Min-Max < ',...
		'Style','radio', ...
		'Enable',enable,...
		'Value',0,...
		'Tag','MinMaxRadio',...
		'Callback','filter_genes_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[80 105 50 20], ...
		'HorizontalAlignment','right', ...
		'String',1,...
		'Style','edit',...
		'Enable','off',...
		'Tag','MinMaxEdit1',...
		'UserData',[0 inf 100 1],...
		'Callback','filter_genes_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[140 103 80 18], ...
		'HorizontalAlignment','left', ...
		'String','oraz Min/Max <', ...
		'Enable',enable,...
		'Style','text', ...
		'Tag','MinMaxText');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[225 105 50 20], ...
		'HorizontalAlignment','right', ...
		'String','2',...
		'Style','edit', ...
		'Enable','off',...
		'Tag','MinMaxEdit2',...
		'UserData',[1 inf 100 1],...
		'Callback','filter_genes_cb(''edit'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 80 150 18], ...
		'String','Usu cechy z listy',...
		'Style','radio', ...
		'Value',(missing_info(1)~=0),...
		'Tag','DelListRadio',...
		'Callback','filter_genes_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 55 150 18], ...
		'String','Pozostaw cechy z listy',...
		'Style','radio', ...
		'Value',0,...
		'Tag','KeepListRadio',...
		'Callback','filter_genes_cb(''radio'')');

if missing_info(1)==0
	enable='off';
else
	enable='on';
end;

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'Position',[140 80 135 20], ...
		'String','Wczytaj list cech', ...
		'Tag','ListButt', ...
		'Enable',enable,...
		'CallBack','filter_genes_cb(''load_list'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 30 240 18], ...
		'String','Zachowaj kolejno cech ze zbioru danych',...
		'Style','checkbox', ...
		'Value',0,...
		'Enable',enable,...
		'Tag','OrderingCheck',...
		'Callback','');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 5 240 18], ...
		'String','Uwzgldniaj tylko cz nazwy do nawiasu',...
		'Style','checkbox', ...
		'Value',0,...
		'Enable',enable,...
		'Tag','ParentesisCheck',...
		'Callback','');


	uicontrol('Parent',Filter_id, ...
		'Units','pixels', ...
		'Position',[205 5 80 25], ...
		'String','Wykonaj', ...
		'Tag','FilterButt', ...
		'CallBack','filter_genes_cb(''filter'')');

	uicontrol('Parent',Filter_id, ...
		'Units','pixels', ...
		'Position',[120 5 80 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
		'Callback','delete(gcbf)');
end;
